(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("ts-dynamic-query", [], factory);
	else if(typeof exports === 'object')
		exports["ts-dynamic-query"] = factory();
	else
		root["ts-dynamic-query"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 20);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.IOUtils = exports.ActionUtils = exports.ThreadUtils = exports.ArrayUtils = exports.HttpUtils = exports.RegexUtils = exports.DateUtils = exports.NumberUtils = exports.StringUtils = exports.ObjectUtils = void 0;
var array_utils_1 = __webpack_require__(15);
Object.defineProperty(exports, "ArrayUtils", { enumerable: true, get: function () { return array_utils_1.ArrayUtils; } });
var date_utils_1 = __webpack_require__(28);
Object.defineProperty(exports, "DateUtils", { enumerable: true, get: function () { return date_utils_1.DateUtils; } });
var http_utils_1 = __webpack_require__(29);
Object.defineProperty(exports, "HttpUtils", { enumerable: true, get: function () { return http_utils_1.HttpUtils; } });
var number_utils_1 = __webpack_require__(10);
Object.defineProperty(exports, "NumberUtils", { enumerable: true, get: function () { return number_utils_1.NumberUtils; } });
var object_utils_1 = __webpack_require__(2);
Object.defineProperty(exports, "ObjectUtils", { enumerable: true, get: function () { return object_utils_1.ObjectUtils; } });
var regex_utils_1 = __webpack_require__(30);
Object.defineProperty(exports, "RegexUtils", { enumerable: true, get: function () { return regex_utils_1.RegexUtils; } });
var string_utils_1 = __webpack_require__(16);
Object.defineProperty(exports, "StringUtils", { enumerable: true, get: function () { return string_utils_1.StringUtils; } });
var thread_utils_1 = __webpack_require__(31);
Object.defineProperty(exports, "ThreadUtils", { enumerable: true, get: function () { return thread_utils_1.ThreadUtils; } });
var action_utils_1 = __webpack_require__(32);
Object.defineProperty(exports, "ActionUtils", { enumerable: true, get: function () { return action_utils_1.ActionUtils; } });
var io_utils_1 = __webpack_require__(33);
Object.defineProperty(exports, "IOUtils", { enumerable: true, get: function () { return io_utils_1.IOUtils; } });
//# sourceMappingURL=index.js.map

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var ClassTransformer_1 = __webpack_require__(7);
var ClassTransformer_2 = __webpack_require__(7);
exports.ClassTransformer = ClassTransformer_2.ClassTransformer;
__export(__webpack_require__(23));
var classTransformer = new ClassTransformer_1.ClassTransformer();
function classToPlain(object, options) {
    return classTransformer.classToPlain(object, options);
}
exports.classToPlain = classToPlain;
function classToPlainFromExist(object, plainObject, options) {
    return classTransformer.classToPlainFromExist(object, plainObject, options);
}
exports.classToPlainFromExist = classToPlainFromExist;
function plainToClass(cls, plain, options) {
    return classTransformer.plainToClass(cls, plain, options);
}
exports.plainToClass = plainToClass;
function plainToClassFromExist(clsObject, plain, options) {
    return classTransformer.plainToClassFromExist(clsObject, plain, options);
}
exports.plainToClassFromExist = plainToClassFromExist;
function classToClass(object, options) {
    return classTransformer.classToClass(object, options);
}
exports.classToClass = classToClass;
function classToClassFromExist(object, fromObject, options) {
    return classTransformer.classToClassFromExist(object, fromObject, options);
}
exports.classToClassFromExist = classToClassFromExist;
function serialize(object, options) {
    return classTransformer.serialize(object, options);
}
exports.serialize = serialize;
/**
 * Deserializes given JSON string to a object of the given class.
 */
function deserialize(cls, json, options) {
    return classTransformer.deserialize(cls, json, options);
}
exports.deserialize = deserialize;
/**
 * Deserializes given JSON string to an array of objects of the given class.
 */
function deserializeArray(cls, json, options) {
    return classTransformer.deserializeArray(cls, json, options);
}
exports.deserializeArray = deserializeArray;
/**
 * Enum representing the different transformation types.
 */
var TransformationType;
(function (TransformationType) {
    TransformationType[TransformationType["PLAIN_TO_CLASS"] = 0] = "PLAIN_TO_CLASS";
    TransformationType[TransformationType["CLASS_TO_PLAIN"] = 1] = "CLASS_TO_PLAIN";
    TransformationType[TransformationType["CLASS_TO_CLASS"] = 2] = "CLASS_TO_CLASS";
})(TransformationType = exports.TransformationType || (exports.TransformationType = {}));

//# sourceMappingURL=index.js.map


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectUtils = void 0;
var __1 = __webpack_require__(0);
var ObjectUtils = /** @class */ (function () {
    function ObjectUtils() {
    }
    /**
     * check whether value is null.
     * @param value
     * @example ObjectUtils.isNull(null)        = true
     * @example ObjectUtils.isNull(undefinend)  = false
     * @example ObjectUtils.isNull({})          = false
     * @example ObjectUtils.isNull(1)           = false
     */
    ObjectUtils.isNull = function (value) {
        return value === null;
    };
    /**
     * check whether value is undefined.
     * @param value
     * @example ObjectUtils.isUndefinend(undefinend)  = true
     * @example ObjectUtils.isUndefinend(null)        = false
     * @example ObjectUtils.isUndefinend({})          = false
     * @example ObjectUtils.isUndefinend(1)           = false
     */
    ObjectUtils.isUndefinend = function (value) {
        return typeof value === "undefined";
    };
    /**
     * check whether value is null or undefined.
     * @param value
     * @example ObjectUtils.isNullOrUndefined(undefinend)  = true
     * @example ObjectUtils.isNullOrUndefined(null)        = true
     * @example ObjectUtils.isNullOrUndefined({})          = false
     * @example ObjectUtils.isNullOrUndefined(1)           = false
     */
    ObjectUtils.isNullOrUndefined = function (value) {
        return this.isNull(value) || this.isUndefinend(value);
    };
    /**
     * check whether value is array.
     * @param value
     * @example ObjectUtils.isArray([])           = true
     * @example ObjectUtils.isArray(null)         = false
     * @example ObjectUtils.isArray(undefinend)   = false
     * @example ObjectUtils.isArray(1)            = false
     */
    ObjectUtils.isArray = function (value) {
        return value instanceof Array;
    };
    /**
     * check whether value is date.
     * @param value
     * @example ObjectUtils.isDate(new Date())   = true
     * @example ObjectUtils.isDate(null)         = false
     * @example ObjectUtils.isDate(undefinend)   = false
     * @example ObjectUtils.isDate(1)            = false
     */
    ObjectUtils.isDate = function (value) {
        return value instanceof Date;
    };
    /**
     * check whether value is string.
     * @param value
     * @example ObjectUtils.isString("test")       = true
     * @example ObjectUtils.isString(null)         = false
     * @example ObjectUtils.isString(undefinend)   = false
     * @example ObjectUtils.isString(1)            = false
     */
    ObjectUtils.isString = function (value) {
        return typeof value === "string";
    };
    /**
     * check whether value is number.
     * @param value
     * @example ObjectUtils.isNumber(1)            = true
     * @example ObjectUtils.isNumber(null)         = false
     * @example ObjectUtils.isNumber(undefinend)   = false
     * @example ObjectUtils.isNumber("test")       = false
     */
    ObjectUtils.isNumber = function (value) {
        return typeof value === "number";
    };
    /**
     * check whether value is boolean.
     * @param value
     * @example ObjectUtils.isBoolean(false)        = true
     * @example ObjectUtils.isBoolean(null)         = false
     * @example ObjectUtils.isBoolean(undefinend)   = false
     * @example ObjectUtils.isBoolean("test")       = false
     */
    ObjectUtils.isBoolean = function (value) {
        return typeof value === "boolean";
    };
    /**
     * Returns a string representation of an object even if value is null or undefined.
     * @param value
     * @param defaultValue
     * @example ObjectUtils.toSafeString(null)            = ""
     * @example ObjectUtils.toSafeString(undefined)       = ""
     * @example ObjectUtils.toSafeString("test")          = "test"
     * @example ObjectUtils.toSafeString(null, "--")      = "--"
     * @example ObjectUtils.toSafeString(undefined, "--") = "--"
     */
    ObjectUtils.toSafeString = function (value, defaultValue) {
        if (defaultValue === void 0) { defaultValue = ""; }
        if (this.isNullOrUndefined(value)) {
            return defaultValue;
        }
        else {
            return value.toString();
        }
    };
    /**
     * get property value of object by key.
     * @param obj
     * @param key
     */
    ObjectUtils.getProperty = function (obj, key) {
        return obj[key]; // Inferred type is T[K]
    };
    /**
     * set property to object.
     * @param obj
     * @param key
     * @param value
     */
    ObjectUtils.setProperty = function (obj, key, value) {
        obj[key] = value;
    };
    /**
     * create object by type.
     * @param type
     */
    ObjectUtils.createObject = function (type) {
        if (this.isNullOrUndefined(type)) {
            return null;
        }
        return new type();
    };
    /**
     * get name of property.
     * @param key
     */
    ObjectUtils.getPropertyName = function (key) {
        return key.toString();
    };
    ObjectUtils.values = function (obj) {
        if (this.isNullOrUndefined(obj)) {
            return [];
        }
        return Object.keys(obj).map(function (key) { return obj[key]; });
    };
    /**
     * get matching descendant property.
     * @param obj
     * @param descendantPaths
     * @example ObjectUtils.getDescendantProperty({p1: {p2 : 1}})             = {p1: {p2 : 1}}
     * @example ObjectUtils.getDescendantProperty({p1: {p2 : 1}}, "p1")       = {p2 : 1}
     * @example ObjectUtils.getDescendantProperty({p1: {p2 : 1}}, "p1", "p2") = 1
     * @example ObjectUtils.getDescendantProperty({p1: {p2 : 1}}, "p1", "p3") = undefined
     * @example ObjectUtils.getDescendantProperty(undefined)                  = undefined
     * @example ObjectUtils.getDescendantProperty(null)                       = undefined
     */
    ObjectUtils.getDescendantProperty = function (obj) {
        var descendantPaths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            descendantPaths[_i - 1] = arguments[_i];
        }
        if (this.isNullOrUndefined(obj)) {
            return undefined;
        }
        if (__1.ArrayUtils.isEmpty(descendantPaths)) {
            return obj;
        }
        var descendantProperty = obj;
        for (var _a = 0, descendantPaths_1 = descendantPaths; _a < descendantPaths_1.length; _a++) {
            var descendantPath = descendantPaths_1[_a];
            descendantProperty = descendantProperty[descendantPath];
            if (ObjectUtils.isNullOrUndefined(descendantProperty)) {
                return undefined;
            }
        }
        return descendantProperty;
    };
    /**
     * if value is null or undefined return default value, else return value.
     * @param value
     * @param defaultValue
     * @example ObjectUtils.getOrDefault<number | undefined>(1, 0)            = "1"
     * @example ObjectUtils.getOrDefault<number | undefined>(undefined, 0)    = "0"
     * @example ObjectUtils.getOrDefault<number | null>(1, 0)                 = "1"
     * @example ObjectUtils.getOrDefault<number | null>(null, 0)              = "0"
     */
    ObjectUtils.getOrDefault = function (value, defaultValue) {
        if (ObjectUtils.isNullOrUndefined(value)) {
            return defaultValue;
        }
        else {
            return value;
        }
    };
    /**
     * Indicating whether the current object has a value.
     * @param object
     * @returns true if current object is not null or undefined, else return false.
     * @example ObjectUtils.hasValue(1)           = true
     * @example ObjectUtils.hasValue("str")       = true
     * @example ObjectUtils.hasValue(undefined)   = false
     * @example ObjectUtils.hasValue(null)        = false
     */
    ObjectUtils.hasValue = function (object) {
        return !this.isNullOrUndefined(object);
    };
    return ObjectUtils;
}());
exports.ObjectUtils = ObjectUtils;
//# sourceMappingURL=object.utils.js.map

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var FilterCondition;

(function (FilterCondition) {
  /**
   * And filter condition.
   */
  FilterCondition[FilterCondition["AND"] = 0] = "AND";
  /**
   * Or filter condition.
   */

  FilterCondition[FilterCondition["OR"] = 1] = "OR";
})(FilterCondition = exports.FilterCondition || (exports.FilterCondition = {}));

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var SortDirection;

(function (SortDirection) {
  /**
   * Asc sort direction.
   */
  SortDirection[SortDirection["ASC"] = 0] = "ASC";
  /**
   * Desc sort direction.
   */

  SortDirection[SortDirection["DESC"] = 1] = "DESC";
})(SortDirection = exports.SortDirection || (exports.SortDirection = {}));

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var __extends = this && this.__extends || function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    };

    return extendStatics(d, b);
  };

  return function (d, b) {
    extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var filterDescriptorBase_1 = __webpack_require__(9);

var filterOperator_1 = __webpack_require__(6);

var class_transformer_1 = __webpack_require__(1);

var ts_commons_1 = __webpack_require__(0);
/**
 * Initializes a new instance of the FilterDescriptor class.
 */


var FilterDescriptor =
/** @class */
function (_super) {
  __extends(FilterDescriptor, _super);

  function FilterDescriptor(options) {
    var _this = _super.call(this, "FilterDescriptor") || this;

    _this.operator = filterOperator_1.FilterOperator.EQUAL;
    _this.propertyPath = null;
    _this.ignoreCase = false;
    _this.value = null;

    if (options) {
      _this.condition = ts_commons_1.ObjectUtils.isNullOrUndefined(options.condition) ? _this.condition : options.condition;
      _this.ignoreCase = ts_commons_1.ObjectUtils.isNullOrUndefined(options.ignoreCase) ? _this.ignoreCase : options.ignoreCase;
      _this.operator = options.operator;
      _this.value = options.value;
      _this.propertyPath = options.propertyPath.toString();
    }

    return _this;
  }
  /**
   * Serialize current FilterDescriptor to json string.
   */


  FilterDescriptor.prototype.toJSON = function () {
    return class_transformer_1.serialize(this);
  };
  /**
   * Deserialize json string to instance of FilterDescriptor.
   * @param json
   */


  FilterDescriptor.prototype.fromJSON = function (json) {
    var obj = class_transformer_1.deserialize(FilterDescriptor, json);
    this.condition = obj.condition;
    this.operator = obj.operator;
    this.value = obj.value;
    this.ignoreCase = obj.ignoreCase;
    this.propertyPath = obj.propertyPath;
    return this;
  };

  return FilterDescriptor;
}(filterDescriptorBase_1.FilterDescriptorBase);

exports.FilterDescriptor = FilterDescriptor;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Defines the operators that you can use to compare a property value to a filter value.
 */

var FilterOperator;

(function (FilterOperator) {
  /**
   * Less than filter operator.
   */
  FilterOperator[FilterOperator["LESS_THAN"] = 0] = "LESS_THAN";
  /**
   * Less than or equal filter operator.
   */

  FilterOperator[FilterOperator["LESS_THAN_OR_EQUAL"] = 1] = "LESS_THAN_OR_EQUAL";
  /**
   * Equal filter operator.
   */

  FilterOperator[FilterOperator["EQUAL"] = 2] = "EQUAL";
  /**
   * Not equal filter operator.
   */

  FilterOperator[FilterOperator["NOT_EQUAL"] = 3] = "NOT_EQUAL";
  /**
   * Greater than or equal filter operator.
   */

  FilterOperator[FilterOperator["GREATER_THAN_OR_EQUAL"] = 4] = "GREATER_THAN_OR_EQUAL";
  /**
   * Greater than filter operator.
   */

  FilterOperator[FilterOperator["GREATER_THAN"] = 5] = "GREATER_THAN";
  /**
   * Start with filter operator.
   */

  FilterOperator[FilterOperator["START_WITH"] = 6] = "START_WITH";
  /**
   * End with filter operator.
   */

  FilterOperator[FilterOperator["END_WITH"] = 7] = "END_WITH";
  /**
   * Contains filter operator.
   */

  FilterOperator[FilterOperator["CONTAINS"] = 8] = "CONTAINS";
  /**
   * In filter operator.
   */

  FilterOperator[FilterOperator["IN"] = 9] = "IN";
  /**
   * Not in filter operator.
   */

  FilterOperator[FilterOperator["NOT_IN"] = 10] = "NOT_IN";
  /**
   * Between filter operator.
   */

  FilterOperator[FilterOperator["BETWEEN"] = 11] = "BETWEEN";
  /**
   * field & value > 0
   */

  FilterOperator[FilterOperator["BITWISE_ANY"] = 12] = "BITWISE_ANY";
  /**
   * field & value = 0
   */

  FilterOperator[FilterOperator["BITWISE_ZERO"] = 13] = "BITWISE_ZERO";
  /**
   * field & value = value
   */

  FilterOperator[FilterOperator["BITWISE_ALL"] = 14] = "BITWISE_ALL";
})(FilterOperator = exports.FilterOperator || (exports.FilterOperator = {}));

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TransformOperationExecutor_1 = __webpack_require__(13);
var ClassTransformer = /** @class */ (function () {
    function ClassTransformer() {
    }
    ClassTransformer.prototype.classToPlain = function (object, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.CLASS_TO_PLAIN, options || {});
        return executor.transform(undefined, object, undefined, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.classToPlainFromExist = function (object, plainObject, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.CLASS_TO_PLAIN, options || {});
        return executor.transform(plainObject, object, undefined, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.plainToClass = function (cls, plain, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.PLAIN_TO_CLASS, options || {});
        return executor.transform(undefined, plain, cls, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.plainToClassFromExist = function (clsObject, plain, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.PLAIN_TO_CLASS, options || {});
        return executor.transform(clsObject, plain, undefined, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.classToClass = function (object, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.CLASS_TO_CLASS, options || {});
        return executor.transform(undefined, object, undefined, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.classToClassFromExist = function (object, fromObject, options) {
        var executor = new TransformOperationExecutor_1.TransformOperationExecutor(TransformOperationExecutor_1.TransformationType.CLASS_TO_CLASS, options || {});
        return executor.transform(fromObject, object, undefined, undefined, undefined, undefined);
    };
    ClassTransformer.prototype.serialize = function (object, options) {
        return JSON.stringify(this.classToPlain(object, options));
    };
    /**
     * Deserializes given JSON string to a object of the given class.
     */
    ClassTransformer.prototype.deserialize = function (cls, json, options) {
        var jsonObject = JSON.parse(json);
        return this.plainToClass(cls, jsonObject, options);
    };
    /**
     * Deserializes given JSON string to an array of objects of the given class.
     */
    ClassTransformer.prototype.deserializeArray = function (cls, json, options) {
        var jsonObject = JSON.parse(json);
        return this.plainToClass(cls, jsonObject, options);
    };
    return ClassTransformer;
}());
exports.ClassTransformer = ClassTransformer;

//# sourceMappingURL=ClassTransformer.js.map


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var filterDescriptor_1 = __webpack_require__(5);

var filterGroupDescriptor_1 = __webpack_require__(11);

var filterOperator_1 = __webpack_require__(6);

var filterCondition_1 = __webpack_require__(3);

var ts_commons_1 = __webpack_require__(0);

var class_transformer_1 = __webpack_require__(1);

var FilterHelper =
/** @class */
function () {
  function FilterHelper() {}

  FilterHelper.predicateByFilters = function (obj, filters) {
    var filterGroupDescriptor = new filterGroupDescriptor_1.FilterGroupDescriptor();
    filterGroupDescriptor.addFilters(filters);
    return this.predicateByFilterGroupDescriptor(obj, filterGroupDescriptor);
  };

  FilterHelper.predicateByFilterGroupDescriptor = function (obj, filterGroupDescriptor) {
    var filters = filterGroupDescriptor.filters;

    if (ts_commons_1.ArrayUtils.isEmpty(filters)) {
      return true;
    }

    var result = null; // if filter is empty, result default value is true

    for (var _i = 0, filters_1 = filters; _i < filters_1.length; _i++) {
      var filter = filters_1[_i];

      if (result === false && !ts_commons_1.ObjectUtils.isNullOrUndefined(filter) && filter.condition === filterCondition_1.FilterCondition.AND) {
        continue;
      }

      if (result === true && !ts_commons_1.ObjectUtils.isNullOrUndefined(filter) && filter.condition === filterCondition_1.FilterCondition.OR) {
        continue;
      }

      var predictResult = void 0;

      if (filter instanceof filterDescriptor_1.FilterDescriptor) {
        predictResult = this.predicateByFilterDescriptor(obj, filter);
      } else if (filter instanceof filterGroupDescriptor_1.FilterGroupDescriptor) {
        predictResult = this.predicateByFilterGroupDescriptor(obj, filter);
      } else {
        predictResult = false;
      }

      if (ts_commons_1.ObjectUtils.isNullOrUndefined(result)) {
        result = predictResult;
      } else {
        switch (filter.condition) {
          case filterCondition_1.FilterCondition.AND:
            result = result && predictResult;
            break;

          case filterCondition_1.FilterCondition.OR:
            result = result || predictResult;
            break;
        }
      }
    }

    return result;
  };

  FilterHelper.predicateByFilterDescriptor = function (obj, filterDescriptor) {
    var operator = filterDescriptor.operator;
    var propertyPath = filterDescriptor.propertyPath;
    var filterValue = filterDescriptor.value;
    var ignoreCase = filterDescriptor.ignoreCase;

    switch (operator) {
      case filterOperator_1.FilterOperator.EQUAL:
        return this.predicateEqual(obj, propertyPath, filterValue, ignoreCase);

      case filterOperator_1.FilterOperator.NOT_EQUAL:
        return this.predicateNotEqual(obj, propertyPath, filterValue, ignoreCase);

      case filterOperator_1.FilterOperator.LESS_THAN:
        return this.predicateLessThan(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.LESS_THAN_OR_EQUAL:
        return this.predicateLessThanOrEqual(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.GREATER_THAN_OR_EQUAL:
        return this.predicateGreaterThanOrEqual(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.GREATER_THAN:
        return this.predicateGreaterThan(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.START_WITH:
        return this.predicateStartWith(obj, propertyPath, filterValue, ignoreCase);

      case filterOperator_1.FilterOperator.END_WITH:
        return this.predicateEndWith(obj, propertyPath, filterValue, ignoreCase);

      case filterOperator_1.FilterOperator.CONTAINS:
        return this.predicateContains(obj, propertyPath, filterValue, ignoreCase);

      case filterOperator_1.FilterOperator.IN:
        return this.predicateIn(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.NOT_IN:
        return this.predicateNotIn(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.BETWEEN:
        var filterValues = this.getFilterValues(filterOperator_1.FilterOperator.BETWEEN, filterValue);
        return this.predicateGreaterThanOrEqual(obj, propertyPath, filterValues[0]) && this.predicateLessThanOrEqual(obj, propertyPath, filterValues[1]);

      case filterOperator_1.FilterOperator.BITWISE_ANY:
        return this.predicateBitwiseAny(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.BITWISE_ZERO:
        return this.predicateBitwiseZero(obj, propertyPath, filterValue);

      case filterOperator_1.FilterOperator.BITWISE_ALL:
        return this.predicateBitwiseAll(obj, propertyPath, filterValue);

      default:
        return false;
    }
  };

  FilterHelper.predicateEqual = function (obj, propertyPath, filterValue, ignoreCase) {
    var propValue = obj[propertyPath];

    if (typeof propValue === "string" && typeof filterValue === "string") {
      return ignoreCase ? ts_commons_1.StringUtils.equalsIgnoreCase(propValue, filterValue) : ts_commons_1.StringUtils.equals(propValue, filterValue);
    } else {
      var userPropValue = this.getValue(propValue);
      var useFilterValue = this.getValue(filterValue);
      return userPropValue === useFilterValue;
    }
  };

  FilterHelper.predicateNotEqual = function (obj, propertyPath, filterValue, ignoreCase) {
    return !this.predicateEqual(obj, propertyPath, filterValue, ignoreCase);
  };

  FilterHelper.predicateLessThan = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    var userPropValue = this.getValue(propValue);
    var useFilterValue = this.getValue(filterValue);
    return userPropValue < useFilterValue;
  };

  FilterHelper.predicateLessThanOrEqual = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    var userPropValue = this.getValue(propValue);
    var useFilterValue = this.getValue(filterValue);
    return userPropValue <= useFilterValue;
  };

  FilterHelper.predicateGreaterThanOrEqual = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    var userPropValue = this.getValue(propValue);
    var useFilterValue = this.getValue(filterValue);
    return userPropValue >= useFilterValue;
  };

  FilterHelper.predicateGreaterThan = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    var userPropValue = this.getValue(propValue);
    var useFilterValue = this.getValue(filterValue);
    return userPropValue > useFilterValue;
  };

  FilterHelper.predicateStartWith = function (obj, propertyPath, filterValue, ignoreCase) {
    var propValue = obj[propertyPath];

    if (ts_commons_1.ObjectUtils.isNullOrUndefined(propValue)) {
      return false;
    }

    var usePropValue = ts_commons_1.ObjectUtils.toSafeString(propValue);
    var useFilterValue = ts_commons_1.ObjectUtils.toSafeString(filterValue);
    return ignoreCase ? ts_commons_1.StringUtils.startWithIgnoreCase(usePropValue, useFilterValue) : ts_commons_1.StringUtils.startWith(usePropValue, useFilterValue);
  };

  FilterHelper.predicateEndWith = function (obj, propertyPath, filterValue, ignoreCase) {
    var propValue = obj[propertyPath];

    if (ts_commons_1.ObjectUtils.isNullOrUndefined(propValue)) {
      return false;
    }

    var usePropValue = ts_commons_1.ObjectUtils.toSafeString(propValue);
    var useFilterValue = ts_commons_1.ObjectUtils.toSafeString(filterValue);
    return ignoreCase ? ts_commons_1.StringUtils.endWithIgnoreCase(usePropValue, useFilterValue) : ts_commons_1.StringUtils.endWith(usePropValue, useFilterValue);
  };

  FilterHelper.predicateContains = function (obj, propertyPath, filterValue, ignoreCase) {
    var propValue = obj[propertyPath];

    if (ts_commons_1.ObjectUtils.isNullOrUndefined(propValue)) {
      return false;
    }

    var usePropValue = ts_commons_1.ObjectUtils.toSafeString(propValue);
    var useFilterValue = ts_commons_1.ObjectUtils.toSafeString(filterValue);
    return ignoreCase ? ts_commons_1.StringUtils.containsIgnoreCase(usePropValue, useFilterValue) : ts_commons_1.StringUtils.contains(usePropValue, useFilterValue);
  };

  FilterHelper.predicateIn = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    var useFilterValues = this.getFilterValues(filterOperator_1.FilterOperator.IN, filterValue);
    return ts_commons_1.ArrayUtils.contains(useFilterValues, propValue);
  };

  FilterHelper.predicateNotIn = function (obj, propertyPath, filterValue) {
    return !this.predicateIn(obj, propertyPath, filterValue);
  };

  FilterHelper.predicateBitwiseAny = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    return (propValue & filterValue) > 0;
  };

  FilterHelper.predicateBitwiseZero = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    return (propValue & filterValue) === 0;
  };

  FilterHelper.predicateBitwiseAll = function (obj, propertyPath, filterValue) {
    var propValue = obj[propertyPath];
    return (propValue & filterValue) === filterValue;
  };

  FilterHelper.getFilterValues = function (operator, filterValue) {
    var result = [];

    if (operator === filterOperator_1.FilterOperator.IN || operator === filterOperator_1.FilterOperator.NOT_IN || operator === filterOperator_1.FilterOperator.BETWEEN) {
      if (ts_commons_1.ObjectUtils.isArray(filterValue)) {
        result = filterValue;

        if (operator === filterOperator_1.FilterOperator.BETWEEN && result.length !== 2) {
          var errMsg = 'if "BETWEEN" operator, the count of filter value must be 2';
          throw new TypeError(errMsg);
        }
      } else {
        var errMsg = 'filter value of "IN" or "NOT_IN" operator must be array';
        throw new TypeError(errMsg);
      }
    } else {
      result.push(filterValue);
    }

    return result;
  };

  FilterHelper.getRealFilters = function (filters) {
    if (ts_commons_1.ArrayUtils.isEmpty(filters)) {
      return [];
    }

    var result = [];

    for (var _i = 0, _a = filters || []; _i < _a.length; _i++) {
      var filterBase = _a[_i];
      var filterJson = class_transformer_1.serialize(filterBase);

      switch (filterBase.type) {
        case "FilterDescriptor":
          result.push(new filterDescriptor_1.FilterDescriptor().fromJSON(filterJson));
          break;

        case "FilterGroupDescriptor":
          result.push(new filterGroupDescriptor_1.FilterGroupDescriptor().fromJSON(filterJson));
          break;
      }
    }

    return result;
  };

  FilterHelper.getValue = function (value) {
    return ts_commons_1.ObjectUtils.isNullOrUndefined(value) ? undefined : value;
  };

  return FilterHelper;
}();

exports.FilterHelper = FilterHelper;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var filterCondition_1 = __webpack_require__(3);
/**
 * Base class for all FilterDescriptor.
 */


var FilterDescriptorBase =
/** @class */
function () {
  function FilterDescriptorBase(type) {
    this.condition = filterCondition_1.FilterCondition.AND;
    this.type = type;
  }

  return FilterDescriptorBase;
}();

exports.FilterDescriptorBase = FilterDescriptorBase;

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberUtils = void 0;
var object_utils_1 = __webpack_require__(2);
// isInteger and isSafeInteger cannot be found in IE
var NumberUtils = /** @class */ (function () {
    function NumberUtils() {
    }
    /**
     * check whether current value is integer
     * @param value
     * @example Number.isInteger(0);         // true
     * @example Number.isInteger(1);         // true
     * @example Number.isInteger(-100000);   // true
     * @example Number.isInteger(99999999999999999999999); // true
     * @example Number.isInteger(0.1);       // false
     * @example Number.isInteger(Math.PI);   // false
     * @example Number.isInteger(NaN);       // false
     * @example Number.isInteger(Infinity);  // false
     * @example Number.isInteger(-Infinity); // false
     * @example Number.isInteger('10');      // false
     * @example Number.isInteger(true);      // false
     * @example Number.isInteger(false);     // false
     * @example Number.isInteger([1]);       // false
     */
    NumberUtils.isInteger = function (value) {
        return (object_utils_1.ObjectUtils.isNumber(value) &&
            isFinite(value) &&
            Math.floor(value) === value);
    };
    /**
     * check whether current value is safe integer
     * @param value
     * @example Number.isSafeInteger(3);                    // true
     * @example Number.isSafeInteger(Math.pow(2, 53));      // false
     * @example Number.isSafeInteger(Math.pow(2, 53) - 1);  // true
     * @example Number.isSafeInteger(NaN);                  // false
     * @example Number.isSafeInteger(Infinity);             // false
     * @example Number.isSafeInteger('3');                  // false
     * @example Number.isSafeInteger(3.1);                  // false
     * @example Number.isSafeInteger(3.0);                  // true
     */
    NumberUtils.isSafeInteger = function (value) {
        return this.isInteger(value) && Math.abs(value) <= this.MAX_SAFE_INTEGER;
    };
    /**
     * Returns a string representing a number in fixed-point notation.
     * @param value target value.
     * @param fractionDigits Number of digits after the decimal point. Must be in the range 0 - 20, inclusive.
     * @param defaultValue default value if value is empty.
     */
    NumberUtils.toFixed = function (value, fractionDigits, defaultValue) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(value)) {
            return object_utils_1.ObjectUtils.getOrDefault(defaultValue, "");
        }
        return value.toFixed(fractionDigits);
    };
    NumberUtils.MAX_SAFE_INTEGER = 9007199254740991;
    NumberUtils.MIN_SAFE_INTEGER = -9007199254740991;
    return NumberUtils;
}());
exports.NumberUtils = NumberUtils;
//# sourceMappingURL=number.utils.js.map

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var __extends = this && this.__extends || function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    };

    return extendStatics(d, b);
  };

  return function (d, b) {
    extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var filterDescriptorBase_1 = __webpack_require__(9);

var class_transformer_1 = __webpack_require__(1);

var filterDescriptor_1 = __webpack_require__(5);

var filterHelper_1 = __webpack_require__(8);
/**
 * Initializes a new instance of the FilterGroupDescriptor class.
 */


var FilterGroupDescriptor =
/** @class */
function (_super) {
  __extends(FilterGroupDescriptor, _super);

  function FilterGroupDescriptor() {
    var _this = _super.call(this, "FilterGroupDescriptor") || this;

    _this.filters = [];
    return _this;
  }
  /**
   * Add filter array to group.
   * @param filters
   */


  FilterGroupDescriptor.prototype.addFilters = function (filters) {
    this.filters = this.filters.concat(filters);
    return this;
  };
  /**
   * Add filter item to group
   * @param filterOptions
   */


  FilterGroupDescriptor.prototype.addFilter = function (filterOptions) {
    var filter = new filterDescriptor_1.FilterDescriptor(filterOptions);
    this.filters.push(filter);
    return this;
  };
  /**
   * Serialize current FilterGroupDescriptor to json string.
   */


  FilterGroupDescriptor.prototype.toJSON = function () {
    return class_transformer_1.serialize(this);
  };
  /**
   * Deserialize json string to instance of FilterGroupDescriptor.
   * @param json
   */


  FilterGroupDescriptor.prototype.fromJSON = function (json) {
    var obj = class_transformer_1.deserialize(FilterGroupDescriptor, json);
    this.filters = filterHelper_1.FilterHelper.getRealFilters(obj.filters);
    this.condition = obj.condition;
    return this;
  };

  return FilterGroupDescriptor;
}(filterDescriptorBase_1.FilterDescriptorBase);

exports.FilterGroupDescriptor = FilterGroupDescriptor;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var __extends = this && this.__extends || function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    };

    return extendStatics(d, b);
  };

  return function (d, b) {
    extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var sortDescriptorBase_1 = __webpack_require__(17);

var sortDirection_1 = __webpack_require__(4);

var class_transformer_1 = __webpack_require__(1);

var ts_commons_1 = __webpack_require__(0);
/**
 * Initializes a new instance of the SortDescriptor class.
 */


var SortDescriptor =
/** @class */
function (_super) {
  __extends(SortDescriptor, _super);

  function SortDescriptor(options) {
    var _this = _super.call(this, "SortDescriptor") || this;

    _this.propertyPath = null;
    _this.direction = sortDirection_1.SortDirection.ASC;

    if (options) {
      _this.direction = ts_commons_1.ObjectUtils.isNullOrUndefined(options.direction) ? sortDirection_1.SortDirection.ASC : options.direction;
      _this.propertyPath = options.propertyPath.toString();
    }

    return _this;
  }
  /**
   * Serialize current SortDescriptor to json string.
   */


  SortDescriptor.prototype.toJSON = function () {
    return class_transformer_1.serialize(this);
  };
  /**
   * Deserialize json string to instance of SortDescriptor.
   * @param json
   */


  SortDescriptor.prototype.fromJSON = function (json) {
    var obj = class_transformer_1.deserialize(SortDescriptor, json);
    this.direction = obj.direction;
    this.propertyPath = obj.propertyPath;
    return this;
  };

  return SortDescriptor;
}(sortDescriptorBase_1.SortDescriptorBase);

exports.SortDescriptor = SortDescriptor;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var storage_1 = __webpack_require__(14);
var TransformationType;
(function (TransformationType) {
    TransformationType[TransformationType["PLAIN_TO_CLASS"] = 0] = "PLAIN_TO_CLASS";
    TransformationType[TransformationType["CLASS_TO_PLAIN"] = 1] = "CLASS_TO_PLAIN";
    TransformationType[TransformationType["CLASS_TO_CLASS"] = 2] = "CLASS_TO_CLASS";
})(TransformationType = exports.TransformationType || (exports.TransformationType = {}));
var TransformOperationExecutor = /** @class */ (function () {
    // -------------------------------------------------------------------------
    // Constructor
    // -------------------------------------------------------------------------
    function TransformOperationExecutor(transformationType, options) {
        this.transformationType = transformationType;
        this.options = options;
        // -------------------------------------------------------------------------
        // Private Properties
        // -------------------------------------------------------------------------
        this.transformedTypesMap = new Map();
    }
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    TransformOperationExecutor.prototype.transform = function (source, value, targetType, arrayType, isMap, level) {
        var _this = this;
        if (level === void 0) { level = 0; }
        if (value instanceof Array || value instanceof Set) {
            var newValue_1 = arrayType && this.transformationType === TransformationType.PLAIN_TO_CLASS ? new arrayType() : [];
            value.forEach(function (subValue, index) {
                var subSource = source ? source[index] : undefined;
                if (!_this.options.enableCircularCheck || !_this.isCircular(subValue, level)) {
                    var value_1 = _this.transform(subSource, subValue, targetType, undefined, subValue instanceof Map, level + 1);
                    if (newValue_1 instanceof Set) {
                        newValue_1.add(value_1);
                    }
                    else {
                        newValue_1.push(value_1);
                    }
                }
                else if (_this.transformationType === TransformationType.CLASS_TO_CLASS) {
                    if (newValue_1 instanceof Set) {
                        newValue_1.add(subValue);
                    }
                    else {
                        newValue_1.push(subValue);
                    }
                }
            });
            return newValue_1;
        }
        else if (targetType === String && !isMap) {
            return String(value);
        }
        else if (targetType === Number && !isMap) {
            return Number(value);
        }
        else if (targetType === Boolean && !isMap) {
            return Boolean(value);
        }
        else if ((targetType === Date || value instanceof Date) && !isMap) {
            if (value instanceof Date) {
                return new Date(value.valueOf());
            }
            if (value === null || value === undefined)
                return value;
            return new Date(value);
        }
        else if (typeof value === "object" && value !== null) {
            // try to guess the type
            if (!targetType && value.constructor !== Object /* && TransformationType === TransformationType.CLASS_TO_PLAIN*/)
                targetType = value.constructor;
            if (!targetType && source)
                targetType = source.constructor;
            if (this.options.enableCircularCheck) {
                // add transformed type to prevent circular references
                this.transformedTypesMap.set(value, { level: level, object: value });
            }
            var keys = this.getKeys(targetType, value);
            var newValue = source ? source : {};
            if (!source && (this.transformationType === TransformationType.PLAIN_TO_CLASS || this.transformationType === TransformationType.CLASS_TO_CLASS)) {
                if (isMap) {
                    newValue = new Map();
                }
                else if (targetType) {
                    newValue = new targetType();
                }
                else {
                    newValue = {};
                }
            }
            var _loop_1 = function (key) {
                var valueKey = key, newValueKey = key, propertyName = key;
                if (!this_1.options.ignoreDecorators && targetType) {
                    if (this_1.transformationType === TransformationType.PLAIN_TO_CLASS) {
                        var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadataByCustomName(targetType, key);
                        if (exposeMetadata) {
                            propertyName = exposeMetadata.propertyName;
                            newValueKey = exposeMetadata.propertyName;
                        }
                    }
                    else if (this_1.transformationType === TransformationType.CLASS_TO_PLAIN || this_1.transformationType === TransformationType.CLASS_TO_CLASS) {
                        var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadata(targetType, key);
                        if (exposeMetadata && exposeMetadata.options && exposeMetadata.options.name)
                            newValueKey = exposeMetadata.options.name;
                    }
                }
                // get a subvalue
                var subValue = undefined;
                if (value instanceof Map) {
                    subValue = value.get(valueKey);
                }
                else if (value[valueKey] instanceof Function) {
                    subValue = value[valueKey]();
                }
                else {
                    subValue = value[valueKey];
                }
                // determine a type
                var type = undefined, isSubValueMap = subValue instanceof Map;
                if (targetType && isMap) {
                    type = targetType;
                }
                else if (targetType) {
                    var metadata = storage_1.defaultMetadataStorage.findTypeMetadata(targetType, propertyName);
                    if (metadata) {
                        var options = { newObject: newValue, object: value, property: propertyName };
                        type = metadata.typeFunction(options);
                        isSubValueMap = isSubValueMap || metadata.reflectedType === Map;
                    }
                    else if (this_1.options.targetMaps) {
                        this_1.options.targetMaps
                            .filter(function (map) { return map.target === targetType && !!map.properties[propertyName]; })
                            .forEach(function (map) { return type = map.properties[propertyName]; });
                    }
                }
                // if value is an array try to get its custom array type
                var arrayType_1 = value[valueKey] instanceof Array ? this_1.getReflectedType(targetType, propertyName) : undefined;
                // const subValueKey = TransformationType === TransformationType.PLAIN_TO_CLASS && newKeyName ? newKeyName : key;
                var subSource = source ? source[valueKey] : undefined;
                // if its deserialization then type if required
                // if we uncomment this types like string[] will not work
                // if (this.transformationType === TransformationType.PLAIN_TO_CLASS && !type && subValue instanceof Object && !(subValue instanceof Date))
                //     throw new Error(`Cannot determine type for ${(targetType as any).name }.${propertyName}, did you forget to specify a @Type?`);
                // if newValue is a source object that has method that match newKeyName then skip it
                if (newValue.constructor.prototype) {
                    var descriptor = Object.getOwnPropertyDescriptor(newValue.constructor.prototype, newValueKey);
                    if ((this_1.transformationType === TransformationType.PLAIN_TO_CLASS || this_1.transformationType === TransformationType.CLASS_TO_CLASS)
                        && (newValue[newValueKey] instanceof Function || (descriptor && !descriptor.set)))
                        return "continue";
                }
                if (!this_1.options.enableCircularCheck || !this_1.isCircular(subValue, level)) {
                    var transformKey = this_1.transformationType === TransformationType.PLAIN_TO_CLASS ? newValueKey : key;
                    var finalValue = this_1.transform(subSource, subValue, type, arrayType_1, isSubValueMap, level + 1);
                    finalValue = this_1.applyCustomTransformations(finalValue, targetType, transformKey, value, this_1.transformationType);
                    if (newValue instanceof Map) {
                        newValue.set(newValueKey, finalValue);
                    }
                    else {
                        newValue[newValueKey] = finalValue;
                    }
                }
                else if (this_1.transformationType === TransformationType.CLASS_TO_CLASS) {
                    var finalValue = subValue;
                    finalValue = this_1.applyCustomTransformations(finalValue, targetType, key, value, this_1.transformationType);
                    if (newValue instanceof Map) {
                        newValue.set(newValueKey, finalValue);
                    }
                    else {
                        newValue[newValueKey] = finalValue;
                    }
                }
            };
            var this_1 = this;
            // traverse over keys
            for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                var key = keys_1[_i];
                _loop_1(key);
            }
            return newValue;
        }
        else {
            return value;
        }
    };
    TransformOperationExecutor.prototype.applyCustomTransformations = function (value, target, key, obj, transformationType) {
        var _this = this;
        var metadatas = storage_1.defaultMetadataStorage.findTransformMetadatas(target, key, this.transformationType);
        // apply versioning options
        if (this.options.version !== undefined) {
            metadatas = metadatas.filter(function (metadata) {
                if (!metadata.options)
                    return true;
                return _this.checkVersion(metadata.options.since, metadata.options.until);
            });
        }
        // apply grouping options
        if (this.options.groups && this.options.groups.length) {
            metadatas = metadatas.filter(function (metadata) {
                if (!metadata.options)
                    return true;
                return _this.checkGroups(metadata.options.groups);
            });
        }
        else {
            metadatas = metadatas.filter(function (metadata) {
                return !metadata.options || !metadata.options.groups || !metadata.options.groups.length;
            });
        }
        metadatas.forEach(function (metadata) {
            value = metadata.transformFn(value, obj, transformationType);
        });
        return value;
    };
    // preventing circular references
    TransformOperationExecutor.prototype.isCircular = function (object, level) {
        var transformed = this.transformedTypesMap.get(object);
        return transformed !== undefined && transformed.level < level;
    };
    TransformOperationExecutor.prototype.getReflectedType = function (target, propertyName) {
        if (!target)
            return undefined;
        var meta = storage_1.defaultMetadataStorage.findTypeMetadata(target, propertyName);
        return meta ? meta.reflectedType : undefined;
    };
    TransformOperationExecutor.prototype.getKeys = function (target, object) {
        var _this = this;
        // determine exclusion strategy
        var strategy = storage_1.defaultMetadataStorage.getStrategy(target);
        if (strategy === "none")
            strategy = this.options.strategy || "exposeAll"; // exposeAll is default strategy
        // get all keys that need to expose
        var keys = [];
        if (strategy === "exposeAll") {
            if (object instanceof Map) {
                keys = Array.from(object.keys());
            }
            else {
                keys = Object.keys(object);
            }
        }
        if (!this.options.ignoreDecorators && target) {
            // add all exposed to list of keys
            var exposedProperties = storage_1.defaultMetadataStorage.getExposedProperties(target, this.transformationType);
            if (this.transformationType === TransformationType.PLAIN_TO_CLASS) {
                exposedProperties = exposedProperties.map(function (key) {
                    var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadata(target, key);
                    if (exposeMetadata && exposeMetadata.options && exposeMetadata.options.name) {
                        return exposeMetadata.options.name;
                    }
                    return key;
                });
            }
            keys = keys.concat(exposedProperties);
            // exclude excluded properties
            var excludedProperties_1 = storage_1.defaultMetadataStorage.getExcludedProperties(target, this.transformationType);
            if (excludedProperties_1.length > 0) {
                keys = keys.filter(function (key) {
                    return excludedProperties_1.indexOf(key) === -1;
                });
            }
            // apply versioning options
            if (this.options.version !== undefined) {
                keys = keys.filter(function (key) {
                    var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadata(target, key);
                    if (!exposeMetadata || !exposeMetadata.options)
                        return true;
                    return _this.checkVersion(exposeMetadata.options.since, exposeMetadata.options.until);
                });
            }
            // apply grouping options
            if (this.options.groups && this.options.groups.length) {
                keys = keys.filter(function (key) {
                    var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadata(target, key);
                    if (!exposeMetadata || !exposeMetadata.options)
                        return true;
                    return _this.checkGroups(exposeMetadata.options.groups);
                });
            }
            else {
                keys = keys.filter(function (key) {
                    var exposeMetadata = storage_1.defaultMetadataStorage.findExposeMetadata(target, key);
                    return !exposeMetadata || !exposeMetadata.options || !exposeMetadata.options.groups || !exposeMetadata.options.groups.length;
                });
            }
        }
        // exclude prefixed properties
        if (this.options.excludePrefixes && this.options.excludePrefixes.length) {
            keys = keys.filter(function (key) { return _this.options.excludePrefixes.every(function (prefix) {
                return key.substr(0, prefix.length) !== prefix;
            }); });
        }
        // make sure we have unique keys
        keys = keys.filter(function (key, index, self) {
            return self.indexOf(key) === index;
        });
        return keys;
    };
    TransformOperationExecutor.prototype.checkVersion = function (since, until) {
        var decision = true;
        if (decision && since)
            decision = this.options.version >= since;
        if (decision && until)
            decision = this.options.version < until;
        return decision;
    };
    TransformOperationExecutor.prototype.checkGroups = function (groups) {
        if (!groups)
            return true;
        return this.options.groups.some(function (optionGroup) { return groups.indexOf(optionGroup) !== -1; });
    };
    return TransformOperationExecutor;
}());
exports.TransformOperationExecutor = TransformOperationExecutor;

//# sourceMappingURL=TransformOperationExecutor.js.map


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var MetadataStorage_1 = __webpack_require__(22);
/**
 * Default metadata storage is used as singleton and can be used to storage all metadatas.
 */
exports.defaultMetadataStorage = new MetadataStorage_1.MetadataStorage();

//# sourceMappingURL=storage.js.map


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayUtils = void 0;
var number_utils_1 = __webpack_require__(10);
var object_utils_1 = __webpack_require__(2);
var ArrayUtils = /** @class */ (function () {
    function ArrayUtils() {
    }
    /**
     * check whether current array is empty or null/undefined.
     * @param array
     * @returns  true if array is empty or null/undefined; otherwise, false.
     * @throws if input parameter is not array type or null/undefined
     * @example ArrayUtils.isEmpty([]) = true;
     * @example ArrayUtils.isEmpty(null) = true;
     * @example ArrayUtils.isEmpty(undefined) = true;
     * @example ArrayUtils.isEmtpy([1]) = false;
     * @example ArrayUtils.isEmtpy("string") throw error;
     * @example ArrayUtils.isEmtpy(123) throw error;
     */
    ArrayUtils.isEmpty = function (array) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(array)) {
            return true;
        }
        if (!object_utils_1.ObjectUtils.isArray(array)) {
            throw new Error("input parameter is not a array or null/undefined");
        }
        return array.length === 0;
    };
    /**
     * check whether current array is not empty or null/undefined.
     * @param array
     * @returns  false if array is empty or null/undefined; otherwise, true.
     * @throws if input parameter is not array type or null/undefined
     * @example ArrayUtils.isNotEmpty([]) = false;
     * @example ArrayUtils.isNotEmpty(null) = false;
     * @example ArrayUtils.isNotEmpty(undefined) = false;
     * @example ArrayUtils.isNotEmpty([1]) = true;
     * @example ArrayUtils.isNotEmpty("string") throw error;
     * @example ArrayUtils.isNotEmpty(123) throw error;
     */
    ArrayUtils.isNotEmpty = function (array) {
        return !this.isEmpty(array);
    };
    /**
     * Determines whether an element is in the array.
     * @param array
     * @param item
     * @returns true if item is in the array; otherwise, false.
     * @example ArrayUtils.contains(null, 1) = false
     * @example ArrayUtils.contains(undefined, 1) = false
     * @example ArrayUtils.contains([], 1) = false
     * @example ArrayUtils.contains([1,2,3], 1) = true
     * @example ArrayUtils.contains([1,2,3], 5) = false
     * @example ArrayUtils.contains([1,2,3], null) = false
     * @example ArrayUtils.contains([1,2,3], undefined) = false
     */
    ArrayUtils.contains = function (array, item) {
        if (this.isEmpty(array) || object_utils_1.ObjectUtils.isNullOrUndefined(item)) {
            return false;
        }
        return array.indexOf(item) !== -1;
    };
    /**
     * Determines whether any of candidates is in the array.
     * @param array
     * @param candidates
     * @returns true if item is in the array; otherwise, false.
     * @example ArrayUtils.containsAny(null, [1, 2]) = false
     * @example ArrayUtils.containsAny(undefined, [1, 2]) = false
     * @example ArrayUtils.containsAny([1, 3, 5], [1, 2]) = true
     * @example ArrayUtils.containsAny([1, 3, 5], [2, 4, 6]) = false
     * @example ArrayUtils.containsAny([1, 3, 5], null) = false
     * @example ArrayUtils.containsAny([1, 3, 5], undefined) = false
     */
    ArrayUtils.containsAny = function (array, candidates) {
        if (this.isEmpty(array) || this.isEmpty(candidates)) {
            return false;
        }
        for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
            var candidate = candidates_1[_i];
            if (array.indexOf(candidate) !== -1) {
                return true;
            }
        }
        return false;
    };
    /**
     * Inserts an element into the array at the specified index.
     * @param array
     * @param index The zero-based index at which item should be inserted.
     * @param item The object to insert. The value can be null for reference types.
     * @returns true if insert successfully, otherwise false.
     * @example ArrayUtils.insert([1, 3], 1, 2) ==> [1, 2, 3]
     * @example ArrayUtils.insert([1, 2], 100, 4) = false // greater than array.length.
     */
    ArrayUtils.insert = function (array, index, item) {
        if (!object_utils_1.ObjectUtils.isArray(array) ||
            !number_utils_1.NumberUtils.isSafeInteger(index) ||
            index > array.length) {
            return false;
        }
        var oldCount = array.length;
        array.splice(index, 0, item);
        return oldCount === array.length - 1;
    };
    /**
     * Removes the first occurrence of a specific object from the array.
     * @param array
     * @param item
     * @returns true if item is successfully removed; otherwise, false.
     * @example  ArrayUtils.remove([1, 2, 3], 2) = true
     * @example  ArrayUtils.remove([1, 2, 3], 5) = false
     */
    ArrayUtils.remove = function (array, item) {
        if (!object_utils_1.ObjectUtils.isArray(array)) {
            return false;
        }
        var index = array.indexOf(item);
        if (index < 0) {
            return false;
        }
        array.splice(index, 1);
        return true;
    };
    /**
     * Find the max number value from array.
     * @param array
     * @returns the max value of the number array.
     * @example  ArrayUtils.max([1,5,3,2,4]) = 5
     */
    ArrayUtils.max = function (array) {
        return Math.max.apply(null, array);
    };
    /**
     * Find the min number value from array.
     * @param array
     * @returns the max value of the number array.
     * @example  ArrayUtils.min([1,5,3,2,4]) = 1
     */
    ArrayUtils.min = function (array) {
        return Math.min.apply(null, array);
    };
    ArrayUtils.take = function (array, n) {
        var length = array.length;
        var takeN;
        if (object_utils_1.ObjectUtils.isNullOrUndefined(n) || isNaN(n)) {
            takeN = 1;
        }
        else if (n <= 0) {
            takeN = 0;
        }
        else if (n < length) {
            takeN = n;
        }
        else {
            takeN = length;
        }
        return array.slice(0, takeN);
    };
    /**
     * Creates a slice of array with n items taken from the end.
     * @param array
     * @returns Array - The slice of the array.
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5]) = [5]
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], null) = [5]
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], NaN) = [5]
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], 3) = [3, 4, 5]
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], 0) = []
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], -2) = []
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], 10) = [1, 2, 3, 4, 5]
     * @example  ArrayUtils.takeRight([1, 2, 3, 4, 5], Number.MAX_VALUE) = [1, 2, 3, 4, 5]
     */
    ArrayUtils.takeRight = function (array, n) {
        var length = array.length;
        var useStartIndex;
        if (object_utils_1.ObjectUtils.isNullOrUndefined(n) || isNaN(n)) {
            // default value is 1
            useStartIndex = length - 1;
        }
        else if (n < 0) {
            useStartIndex = length;
        }
        else if (n < length) {
            useStartIndex = length - n;
        }
        else {
            useStartIndex = 0;
        }
        return array.slice(useStartIndex, length);
    };
    return ArrayUtils;
}());
exports.ArrayUtils = ArrayUtils;
//# sourceMappingURL=array.utils.js.map

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.StringUtils = void 0;
var array_utils_1 = __webpack_require__(15);
var number_utils_1 = __webpack_require__(10);
var object_utils_1 = __webpack_require__(2);
var StringUtils = /** @class */ (function () {
    function StringUtils() {
    }
    /**
     * check current string is empty.
     * @param str
     * @example StringUtils.isEmpty(null)      = true
     * @example StringUtils.isEmpty(undefined) = true
     * @example StringUtils.isEmpty("")        = true
     * @example StringUtils.isEmpty(" ")       = false
     * @example StringUtils.isEmpty("bob")     = false
     * @example StringUtils.isEmpty("  bob  ") = false
     */
    StringUtils.isEmpty = function (str) {
        return object_utils_1.ObjectUtils.isNullOrUndefined(str) || str.length === 0;
    };
    /**
     * check current string is not empty.
     * @param str
     * @example StringUtils.isNotEmpty(null)      = false
     * @example StringUtils.isNotEmpty(undefined) = false
     * @example StringUtils.isNotEmpty("")        = false
     * @example StringUtils.isNotEmpty(" ")       = true
     * @example StringUtils.isNotEmpty("bob")     = true
     * @example StringUtils.isNotEmpty("  bob  ") = true
     */
    StringUtils.isNotEmpty = function (str) {
        return !this.isEmpty(str);
    };
    /**
     * check current string is blank.
     * @param str
     * @example StringUtils.isBlank(null)      = true
     * @example StringUtils.isBlank(undefined) = true
     * @example StringUtils.isBlank("")        = true
     * @example StringUtils.isBlank(" ")       = true
     * @example StringUtils.isBlank("bob")     = false
     * @example StringUtils.isBlank("  bob  ") = false
     */
    StringUtils.isBlank = function (str) {
        return object_utils_1.ObjectUtils.isNullOrUndefined(str) || str.trim() === this.EMPTY;
    };
    /**
     * check current string is not blank.
     * @param str
     * @example StringUtils.isNotBlank(null)      = false
     * @example StringUtils.isNotBlank(undefined) = false
     * @example StringUtils.isNotBlank("")        = false
     * @example StringUtils.isNotBlank(" ")       = false
     * @example StringUtils.isNotBlank("bob")     = true
     * @example StringUtils.isNotBlank("  bob  ") = true
     */
    StringUtils.isNotBlank = function (str) {
        return !this.isBlank(str);
    };
    /**
     * Removes all leading and trailing white-space characters from the current string.
     * @param str
     * @example StringUtils.trim(null)        = null
     * @example StringUtils.trim(undefined)   = undefined
     * @example StringUtils.trim("")          = ""
     * @example StringUtils.trim("    ")      = ""
     * @example StringUtils.trim(" a   ")     = "a"
     */
    StringUtils.trim = function (str) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str)) {
            return str;
        }
        else {
            return str.replace("\b", this.EMPTY).trim();
        }
    };
    /**
     * Removes all leading and trailing white-space characters from the current string to null.
     * @param str
     * @example StringUtils.trimToNull(null)             = null
     * @example StringUtils.trimToNull(undefined)        = null
     * @example StringUtils.trimToNull("")               = null
     * @example StringUtils.trimToNull("    ")           = null
     * @example StringUtils.trimToNull(" a   ")          = "a"
     */
    StringUtils.trimToNull = function (str) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str)) {
            return null;
        }
        var tmp = this.trim(str);
        return this.isBlank(tmp) ? null : tmp;
    };
    /**
     * Removes all leading and trailing white-space characters from the current string to "".
     * @param str
     * @example StringUtils.trimToNull(null)             = ""
     * @example StringUtils.trimToNull(undefined)        = ""
     * @example StringUtils.trimToNull("")               = ""
     * @example StringUtils.trimToNull("    ")           = ""
     * @example StringUtils.trimToNull(" a   ")          = "a"
     */
    StringUtils.trimToEmpty = function (str) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str)) {
            return this.EMPTY;
        }
        var tmp = this.trim(str);
        return this.isBlank(tmp) ? this.EMPTY : tmp;
    };
    /**
     * Strips any of a set of characters from the start and end of a String.
     * @param str
     * @param stripChars
     */
    StringUtils.strip = function (str, stripChars) {
        var tmp = this.stripStart(str, stripChars);
        return this.stripEnd(tmp, stripChars);
    };
    /**
     * Strips whitespace from the start and end of a String returning null if the String is empty ("") after the strip.
     * @param str
     */
    StringUtils.stripToNull = function (str) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str)) {
            return null;
        }
        var tmp = this.strip(str);
        return this.isBlank(tmp) ? null : tmp;
    };
    /**
     * Strips whitespace from the start and end of a String returning an empty String if null input.
     * @param str
     */
    StringUtils.stripToEmpty = function (str) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str)) {
            return this.EMPTY;
        }
        var tmp = this.strip(str);
        return this.isBlank(tmp) ? this.EMPTY : tmp;
    };
    /**
     * Strips any of a set of characters from the start of a String.
     * @param str
     * @param stripChars
     * @example StringUtils.stripStart(null, *)          = null
     * @example StringUtils.stripStart("", *)            = ""
     * @example StringUtils.stripStart("abc", "")        = "abc"
     * @example StringUtils.stripStart("abc", null)      = "abc"
     * @example StringUtils.stripStart("  abc", null)    = "abc"
     * @example StringUtils.stripStart("abc  ", null)    = "abc  "
     * @example StringUtils.stripStart(" abc ", null)    = "abc "
     * @example StringUtils.stripStart("yxabc  ", "xyz") = "abc  "
     */
    StringUtils.stripStart = function (str, stripChars) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str) || str.length === 0) {
            return str;
        }
        var strLen = str.length;
        var start = 0;
        if (object_utils_1.ObjectUtils.isNullOrUndefined(stripChars)) {
            while (start !== strLen && this.isWhitespace(str.charAt(start))) {
                start++;
            }
        }
        else if (stripChars.length === 0) {
            return str;
        }
        else {
            while (start !== strLen && stripChars.indexOf(str.charAt(start)) !== -1) {
                start++;
            }
        }
        return str.substring(start);
    };
    /**
     * Strips any of a set of characters from the end of a String.
     * @param str
     * @param stripChars
     * @example StringUtils.stripEnd(null, *)          = null
     * @example StringUtils.stripEnd("", *)            = ""
     * @example StringUtils.stripEnd("abc", "")        = "abc"
     * @example StringUtils.stripEnd("abc", null)      = "abc"
     * @example StringUtils.stripEnd("  abc", null)    = "  abc"
     * @example StringUtils.stripEnd("abc  ", null)    = "abc"
     * @example StringUtils.stripEnd(" abc ", null)    = " abc"
     * @example StringUtils.stripEnd("  abcyx", "xyz") = "  abc"
     */
    StringUtils.stripEnd = function (str, stripChars) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str) || str.length === 0) {
            return str;
        }
        var end = str.length;
        if (stripChars == null) {
            while (end !== 0 && this.isWhitespace(str.charAt(end - 1))) {
                end--;
            }
        }
        else if (stripChars.length === 0) {
            return str;
        }
        else {
            while (end !== 0 && stripChars.indexOf(str.charAt(end - 1)) !== -1) {
                end--;
            }
        }
        return str.substring(0, end);
    };
    /**
     * Compares two CharSequences, returning true if they represent equal sequences of characters.
     * @param str1
     * @param str2
     * @example StringUtils.equal(null, null)              = true
     * @example StringUtils.equal(undefined, undefined)      = true
     * @example StringUtils.equal(undefined, null)          = false
     * @example StringUtils.equal(null, undefined)          = false
     * @example StringUtils.equal(null, "abc")             = false
     * @example StringUtils.equal("abc", null)             = false
     * @example StringUtils.equal("abc", undefined)         = false
     * @example StringUtils.equal(undefined, "abc")         = false
     * @example StringUtils.equal("abc", "def")            = false
     * @example StringUtils.equal("abc", "abc")            = true
     */
    StringUtils.equals = function (str1, str2) {
        if (!object_utils_1.ObjectUtils.isNullOrUndefined(str1) &&
            !object_utils_1.ObjectUtils.isNullOrUndefined(str2)) {
            return str1 === str2;
        }
        if (object_utils_1.ObjectUtils.isNull(str1) && object_utils_1.ObjectUtils.isNull(str2)) {
            return true;
        }
        if (object_utils_1.ObjectUtils.isUndefinend(str1) && object_utils_1.ObjectUtils.isUndefinend(str2)) {
            return true;
        }
        return false;
    };
    /**
     * Compares two CharSequences, returning true if they represent equal sequences of characters, ignoring case.
     * @param str1
     * @param str2
     * @example StringUtils.equal(null, null)              = true
     * @example StringUtils.equal(undefined, undefined)      = true
     * @example StringUtils.equal(undefined, null)          = false
     * @example StringUtils.equal(null, undefined)          = false
     * @example StringUtils.equal(null, "abc")             = false
     * @example StringUtils.equal("abc", null)             = false
     * @example StringUtils.equal("abc", undefined)         = false
     * @example StringUtils.equal(undefined, "abc")         = false
     * @example StringUtils.equal("abc", "def")            = false
     * @example StringUtils.equal("abc", "abc")            = true
     * @example StringUtils.equal("abc", "AbC")            = true
     */
    StringUtils.equalsIgnoreCase = function (str1, str2) {
        if (!object_utils_1.ObjectUtils.isNullOrUndefined(str1) &&
            !object_utils_1.ObjectUtils.isNullOrUndefined(str2)) {
            return str1.toLocaleLowerCase() === str2.toLocaleLowerCase();
        }
        if (object_utils_1.ObjectUtils.isNull(str1) && object_utils_1.ObjectUtils.isNull(str2)) {
            return true;
        }
        if (object_utils_1.ObjectUtils.isUndefinend(str1) && object_utils_1.ObjectUtils.isUndefinend(str2)) {
            return true;
        }
        return false;
    };
    /**
     * Finds the first index within a CharSequence, handling null.
     * @param str
     * @param searchStr
     * @param startPos
     * @example StringUtils.indexOf(null, *)         = -1
     * @example StringUtils.indexOf(undefined, *)         = -1
     * @example StringUtils.indexOf("", *)           = -1
     * @example StringUtils.indexOf("aabaabaa", 'a') = 0
     * @example StringUtils.indexOf("aabaabaa", 'b') = 2
     * @example StringUtils.indexOf("aabaabaa", 'b', 3) = 5
     * @example StringUtils.indexOf("aabaabaa", '') = 0
     */
    StringUtils.indexOf = function (str, searchStr, startPos) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str) ||
            object_utils_1.ObjectUtils.isNullOrUndefined(searchStr) ||
            (!object_utils_1.ObjectUtils.isUndefinend(startPos) &&
                !number_utils_1.NumberUtils.isSafeInteger(startPos))) {
            return this.INDEX_NOT_FOUND;
        }
        var useStartPos = object_utils_1.ObjectUtils.isUndefinend(startPos) ? 0 : startPos;
        return str.indexOf(searchStr, useStartPos);
    };
    /**
     * Returns the index within seq of the first occurrence of the specified character, starting the search at the specified index.
     * @param str
     * @param searchStr
     * @param position
     * @example StringUtils.lastIndexOf("aFkyk", "k")          =4
     * @example StringUtils.lastIndexOf("a Fkyk", " ");        =1
     * @example StringUtils.lastIndexOf("aabaabaa", "b");      =5
     * @example StringUtils.lastIndexOf("aabaabaa", "b", 4);   =2
     */
    StringUtils.lastIndexOf = function (str, searchStr, position) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(str) ||
            object_utils_1.ObjectUtils.isNullOrUndefined(searchStr) ||
            (!object_utils_1.ObjectUtils.isUndefinend(position) &&
                !number_utils_1.NumberUtils.isSafeInteger(position))) {
            return this.INDEX_NOT_FOUND;
        }
        var usePosition = object_utils_1.ObjectUtils.isUndefinend(position)
            ? str.length - 1
            : position;
        return str.lastIndexOf(searchStr, usePosition);
    };
    /**
     * Checks if CharSequence contains a search character, handling null.
     * @param str
     * @param searchStr
     */
    StringUtils.contains = function (str, searchStr) {
        if (object_utils_1.ObjectUtils.isString(str) && object_utils_1.ObjectUtils.isString(searchStr)) {
            return str.indexOf(searchStr) >= 0;
        }
        else {
            return false;
        }
    };
    /**
     * Checks if CharSequence contains a search CharSequence irrespective of case, handling null.
     * @param str
     * @param searchStr
     */
    StringUtils.containsIgnoreCase = function (str, searchStr) {
        if (object_utils_1.ObjectUtils.isString(str) && object_utils_1.ObjectUtils.isString(searchStr)) {
            return (str.toLocaleLowerCase().indexOf(searchStr.toLocaleLowerCase()) >= 0);
        }
        else {
            return false;
        }
    };
    /**
     * Gets a substring from the specified String avoiding exceptions.
     * @param str
     * @param start
     * @param end
     */
    StringUtils.subString = function (str, start, end) {
        if (!object_utils_1.ObjectUtils.isString(str) ||
            !number_utils_1.NumberUtils.isSafeInteger(start) ||
            (!object_utils_1.ObjectUtils.isUndefinend(end) && !number_utils_1.NumberUtils.isSafeInteger(end))) {
            return null;
        }
        if (str.length === 0) {
            return str;
        }
        if (object_utils_1.ObjectUtils.isUndefinend(end)) {
            return str.substring(start);
        }
        else {
            return str.substring(start, end);
        }
    };
    /**
     * Determines whether the beginning of this string instance matches the specified string.
     * @param str
     * @param prefix
     */
    StringUtils.startWith = function (str, prefix) {
        if (!object_utils_1.ObjectUtils.isString(str) || !object_utils_1.ObjectUtils.isString(prefix)) {
            return false;
        }
        // return str.indexOf(prefix) === 0;
        // according to https://leonax.net/p/5806/use-string-startswith-and-endswith-in-javascript/
        return str.slice(0, prefix.length) === prefix;
    };
    /**
     * Determines whether the beginning of this string instance matches the specified string irrespective of case.
     * @param str
     * @param prefix
     */
    StringUtils.startWithIgnoreCase = function (str, prefix) {
        if (!object_utils_1.ObjectUtils.isString(str) || !object_utils_1.ObjectUtils.isString(prefix)) {
            return false;
        }
        var useStr = str.toLocaleLowerCase();
        var usePrefix = prefix.toLocaleLowerCase();
        return useStr.slice(0, usePrefix.length) === usePrefix;
    };
    /**
     *  Determines whether the end of this string instance matches the specified string.
     * @param str
     * @param suffix
     */
    StringUtils.endWith = function (str, suffix) {
        if (!object_utils_1.ObjectUtils.isString(str) || !object_utils_1.ObjectUtils.isString(suffix)) {
            return false;
        }
        return str.indexOf(suffix, str.length - suffix.length) !== -1;
    };
    /**
     * Determines whether the end of this string instance matches the specified string irrespective of case.
     * @param str
     * @param suffix
     */
    StringUtils.endWithIgnoreCase = function (str, suffix) {
        if (!object_utils_1.ObjectUtils.isString(str) || !object_utils_1.ObjectUtils.isString(suffix)) {
            return false;
        }
        var useStr = str.toLocaleLowerCase();
        var useSuffix = suffix.toLocaleLowerCase();
        return useStr.indexOf(useSuffix, useStr.length - useSuffix.length) !== -1;
    };
    /**
     * check if current char is whitespace
     * @param ch
     */
    StringUtils.isWhitespace = function (ch) {
        return " \f\n\r\t\v\u00A0\u2028\u2029".indexOf(ch) > -1;
    };
    /**
     * Initializes a new string of the guid structure.
     */
    StringUtils.newGuid = function () {
        return (this.S4() +
            this.S4() +
            "-" +
            this.S4() +
            "-" +
            this.S4() +
            "-" +
            this.S4() +
            "-" +
            this.S4() +
            this.S4() +
            this.S4());
    };
    StringUtils.S4 = function () {
        // tslint:disable-next-line:no-bitwise
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    /**
     * JavaScript convert string to snake_case.
     * @example console.log(toSnakeCase('string')); // => string
     * @example console.log(toSnakeCase('camelCase')); // => camel_case
     * @example console.log(toSnakeCase('param-case')); // => param_case
     * @example console.log(toSnakeCase('PascalCase')); // => pascal_case
     * @example console.log(toSnakeCase('UPPER_CASE')); // => upper_case
     * @example console.log(toSnakeCase('snake_case')); // => snake_case
     * @example console.log(toSnakeCase('sentence case')); // => sentence_case
     * @example console.log(toSnakeCase('Title Case')); // => title_case
     * @example console.log(toSnakeCase('dot.case')); // => // dot_case
     * @example
     * @example console.log(toSnakeCase('')); // => ''
     * @example console.log(toSnakeCase(null)); // => ''
     * @example console.log(toSnakeCase(undefined)); // => ''
     * @example
     * @example console.log(toSnakeCase('Abc ___ 123 ___ xYz')); // => abc_123_x_yz
     * @example console.log(toSnakeCase('123__abc  ... ?// {#} def 12')); // => 123_abc_def_12
     * @example console.log(toSnakeCase('	tab space ??? ________')); // => tab_space
     * @example console.log(toSnakeCase('___?||123  abc|| 123..123')); // => 123_abc_123_123
     * @example console.log(toSnakeCase('!@#$%  {}|":;" ABC XyZ G123H')); // => abc_xy_z_g123h
     * @example console.log(toSnakeCase(' ^&* #DEFine x: 15 + ==')); // => define_x_15
     * @example console.log(toSnakeCase('123456789')); // => 123456789
     */
    StringUtils.snakeCase = function (str) {
        if (this.isBlank(str)) {
            return "";
        }
        return String(str)
            .replace(/^[^A-Za-z0-9]*|[^A-Za-z0-9]*$/g, "")
            .replace(/([a-z])([A-Z])/g, function (m, a, b) { return a + "_" + b.toLowerCase(); })
            .replace(/[^A-Za-z0-9]+|_+/g, "_")
            .toLowerCase();
    };
    /**
     * Replaces all text find in a string.
     * @example StringUtils.replaceAll(null, "a", "b")    = null;
     * @example StringUtils.replaceAll(" ", " ", "a")    = "a";
     * @example StringUtils.replaceAll("aa", "a", "b")    = "bb";
     */
    StringUtils.replaceAll = function (str, searchValue, replacer) {
        if (!object_utils_1.ObjectUtils.isString(str) ||
            !object_utils_1.ObjectUtils.isString(searchValue) ||
            !object_utils_1.ObjectUtils.isString(replacer)) {
            return str;
        }
        return str.replace(new RegExp(this.escapeRegExp(searchValue), "g"), replacer);
    };
    /**
     * Joins the elements of the provided array into a single String
     * @param array  the array of values to join together, may be null
     * @param separator the separator character to use, null treated as ""
     * @returns the joined String
     * @example StringUtils.join([], *)    = "";
     * @example StringUtils.join(["a", "b", "c"], null)  = "abc"
     * @example StringUtils.join(["a", "b", "c"], "-")  = "a-b-c"
     * @example StringUtils.join([1, 2, 3], "-")  = "1-2-3"
     */
    StringUtils.join = function (array, separator) {
        if (separator === void 0) { separator = ""; }
        if (array_utils_1.ArrayUtils.isEmpty(array)) {
            return "";
        }
        var useSeparator = this.isEmpty(separator) ? "" : separator;
        var result;
        for (var index = 0; index < array.length; index++) {
            var element = array[index] + "";
            if (index === 0) {
                result = element;
            }
            else {
                result = result + useSeparator + element;
            }
        }
        return result;
    };
    StringUtils.escapeRegExp = function (str) {
        return str.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
    };
    StringUtils.EMPTY = "";
    StringUtils.INDEX_NOT_FOUND = -1;
    return StringUtils;
}());
exports.StringUtils = StringUtils;
//# sourceMappingURL=string.utils.js.map

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var sortDirection_1 = __webpack_require__(4);
/**
 * Base class for all SortDescriptor.
 */


var SortDescriptorBase =
/** @class */
function () {
  function SortDescriptorBase(type) {
    this.direction = sortDirection_1.SortDirection.ASC;
    this.type = type;
  }

  return SortDescriptorBase;
}();

exports.SortDescriptorBase = SortDescriptorBase;

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var ts_commons_1 = __webpack_require__(0);

var filterHelper_1 = __webpack_require__(8);

var sortHelper_1 = __webpack_require__(19);

var QueryProvider =
/** @class */
function () {
  function QueryProvider() {}

  QueryProvider.query = function (datas, query) {
    var _this = this;

    if (ts_commons_1.ArrayUtils.isEmpty(datas)) {
      return [];
    }

    var cloneDatas = datas.slice(0);

    if (ts_commons_1.ObjectUtils.isNullOrUndefined(query)) {
      return cloneDatas;
    }

    if (!ts_commons_1.ArrayUtils.isEmpty(query.filters)) {
      cloneDatas = cloneDatas.filter(function (x) {
        return filterHelper_1.FilterHelper.predicateByFilters(x, query.filters);
      });
    }

    if (!ts_commons_1.ArrayUtils.isEmpty(query.sorts)) {
      cloneDatas = cloneDatas.sort(function (obj1, obj2) {
        return sortHelper_1.SortHelper.predicateBySorts(obj1, obj2, query.sorts);
      });
    }

    if (!ts_commons_1.ArrayUtils.isEmpty(query.selectedProperties)) {
      cloneDatas = cloneDatas.map(function (x) {
        return _this.pick(query.type, x, query.selectedProperties);
      });
    }

    return cloneDatas;
  };

  QueryProvider.pick = function (type, data, selectedProperties) {
    var newObj = ts_commons_1.ObjectUtils.createObject(type);

    for (var key in data) {
      if (selectedProperties.indexOf(key) >= 0) {
        newObj[key] = data[key];
      }
    }

    return newObj;
  };

  return QueryProvider;
}();

exports.QueryProvider = QueryProvider;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var sortDescriptor_1 = __webpack_require__(12);

var sortDirection_1 = __webpack_require__(4);

var ts_commons_1 = __webpack_require__(0);

var class_transformer_1 = __webpack_require__(1);

var SortHelper =
/** @class */
function () {
  function SortHelper() {}

  SortHelper.predicateBySorts = function (obj1, obj2, sorts) {
    var result = 0;

    for (var _i = 0, sorts_1 = sorts; _i < sorts_1.length; _i++) {
      var sort = sorts_1[_i];
      result = this.predicateBySortDescriptorBase(obj1, obj2, sort);

      if (result !== 0) {
        break;
      }
    }

    return result;
  };

  SortHelper.predicateBySortDescriptorBase = function (obj1, obj2, sort) {
    var result = 0;

    if (sort instanceof sortDescriptor_1.SortDescriptor) {
      result = this.predicateBySortDescriptor(obj1, obj2, sort);
    } else {
      result = 0;
    }

    return result;
  };

  SortHelper.predicateBySortDescriptor = function (obj1, obj2, sortDescriptor) {
    var propertyPath = sortDescriptor.propertyPath;
    var direction = sortDescriptor.direction;
    var propValue1 = ts_commons_1.ObjectUtils.getOrDefault(obj1[propertyPath], ts_commons_1.NumberUtils.MIN_SAFE_INTEGER);
    var propValue2 = ts_commons_1.ObjectUtils.getOrDefault(obj2[propertyPath], ts_commons_1.NumberUtils.MIN_SAFE_INTEGER);
    var result = 0;

    switch (direction) {
      case sortDirection_1.SortDirection.ASC:
        if (propValue1 === propValue2) {
          result = 0;
        } else if (propValue1 > propValue2) {
          result = 1;
        } else {
          result = -1;
        }

        break;

      case sortDirection_1.SortDirection.DESC:
        if (propValue1 === propValue2) {
          result = 0;
        } else if (propValue1 < propValue2) {
          result = 1;
        } else {
          result = -1;
        }

        break;
    }

    return result;
  };

  SortHelper.getRealSorts = function (sorts) {
    if (ts_commons_1.ArrayUtils.isEmpty(sorts)) {
      return [];
    }

    var result = [];

    for (var _i = 0, _a = sorts || []; _i < _a.length; _i++) {
      var filterBase = _a[_i];
      var filterJson = class_transformer_1.serialize(filterBase);

      switch (filterBase.type) {
        case "SortDescriptor":
          result.push(new sortDescriptor_1.SortDescriptor().fromJSON(filterJson));
          break;
      }
    }

    return result;
  };

  return SortHelper;
}();

exports.SortHelper = SortHelper;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var filterCondition_1 = __webpack_require__(3);

exports.FilterCondition = filterCondition_1.FilterCondition;

var filterOperator_1 = __webpack_require__(6);

exports.FilterOperator = filterOperator_1.FilterOperator;

var sortDirection_1 = __webpack_require__(4);

exports.SortDirection = sortDirection_1.SortDirection;

var dynamicQuery_1 = __webpack_require__(21);

exports.DynamicQuery = dynamicQuery_1.DynamicQuery;

var filterDescriptor_1 = __webpack_require__(5);

exports.FilterDescriptor = filterDescriptor_1.FilterDescriptor;

var filterDescriptorBase_1 = __webpack_require__(9);

exports.FilterDescriptorBase = filterDescriptorBase_1.FilterDescriptorBase;

var filterGroupDescriptor_1 = __webpack_require__(11);

exports.FilterGroupDescriptor = filterGroupDescriptor_1.FilterGroupDescriptor;

var sortDescriptor_1 = __webpack_require__(12);

exports.SortDescriptor = sortDescriptor_1.SortDescriptor;

var sortDescriptorBase_1 = __webpack_require__(17);

exports.SortDescriptorBase = sortDescriptorBase_1.SortDescriptorBase;

var queryProvider_1 = __webpack_require__(18);

exports.QueryProvider = queryProvider_1.QueryProvider;

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var class_transformer_1 = __webpack_require__(1);

var filterHelper_1 = __webpack_require__(8);

var filterDescriptor_1 = __webpack_require__(5);

var filterGroupDescriptor_1 = __webpack_require__(11);

var sortDescriptor_1 = __webpack_require__(12);

var ts_commons_1 = __webpack_require__(0);

var filterCondition_1 = __webpack_require__(3);

var queryProvider_1 = __webpack_require__(18);

var sortHelper_1 = __webpack_require__(19);

var DynamicQuery =
/** @class */
function () {
  function DynamicQuery() {
    this.filters = [];
    this.sorts = [];
    this.selectedProperties = [];
  }

  DynamicQuery.createQuery = function (type) {
    var instance = new DynamicQuery();
    instance.type = type;
    return instance;
  };

  DynamicQuery.prototype.addFilters = function (filters) {
    this.filters = this.filters.concat(filters);
    return this;
  };

  DynamicQuery.prototype.addFilterDescriptor = function (option) {
    var filter = new filterDescriptor_1.FilterDescriptor(option);
    this.filters.push(filter);
    return this;
  };

  DynamicQuery.prototype.addFilterGroupDescriptor = function (option) {
    var filterGroupDescriptor = new filterGroupDescriptor_1.FilterGroupDescriptor();
    filterGroupDescriptor.condition = ts_commons_1.ObjectUtils.isNullOrUndefined(option.condition) ? filterCondition_1.FilterCondition.AND : option.condition;

    for (var _i = 0, _a = option.options; _i < _a.length; _i++) {
      var subOption = _a[_i];
      filterGroupDescriptor.filters.push(new filterDescriptor_1.FilterDescriptor(subOption));
    }

    this.filters.push(filterGroupDescriptor);
    return this;
  };

  DynamicQuery.prototype.addSorts = function (sorts) {
    this.sorts = this.sorts.concat(sorts);
    return this;
  };

  DynamicQuery.prototype.addSortDescriptor = function (sortOption) {
    var sort = new sortDescriptor_1.SortDescriptor(sortOption);
    this.sorts.push(sort);
    sortOption;
    return this;
  };

  DynamicQuery.prototype.selectProperty = function (property) {
    var propertyStr = property.toString();
    this.selectedProperties.push(propertyStr);
    return this;
  };

  DynamicQuery.prototype.selectProperties = function () {
    var properties = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      properties[_i] = arguments[_i];
    }

    var propertyStrs = properties.map(function (x) {
      return x.toString();
    });
    this.selectedProperties = this.selectedProperties.concat(propertyStrs);
    return this;
  };

  DynamicQuery.prototype.query = function (datas) {
    return queryProvider_1.QueryProvider.query(datas, this);
  };

  DynamicQuery.prototype.toJSON = function () {
    return class_transformer_1.serialize(this);
  };

  DynamicQuery.prototype.fromJSON = function (json) {
    var obj = class_transformer_1.deserialize(DynamicQuery, json);
    this.filters = filterHelper_1.FilterHelper.getRealFilters(obj.filters);
    this.sorts = sortHelper_1.SortHelper.getRealSorts(obj.sorts);
    return this;
  };

  return DynamicQuery;
}();

exports.DynamicQuery = DynamicQuery;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TransformOperationExecutor_1 = __webpack_require__(13);
/**
 * Storage all library metadata.
 */
var MetadataStorage = /** @class */ (function () {
    function MetadataStorage() {
        // -------------------------------------------------------------------------
        // Properties
        // -------------------------------------------------------------------------
        this._typeMetadatas = [];
        this._transformMetadatas = [];
        this._exposeMetadatas = [];
        this._excludeMetadatas = [];
    }
    // -------------------------------------------------------------------------
    // Adder Methods
    // -------------------------------------------------------------------------
    MetadataStorage.prototype.addTypeMetadata = function (metadata) {
        this._typeMetadatas.push(metadata);
    };
    MetadataStorage.prototype.addTransformMetadata = function (metadata) {
        this._transformMetadatas.push(metadata);
    };
    MetadataStorage.prototype.addExposeMetadata = function (metadata) {
        this._exposeMetadatas.push(metadata);
    };
    MetadataStorage.prototype.addExcludeMetadata = function (metadata) {
        this._excludeMetadatas.push(metadata);
    };
    // -------------------------------------------------------------------------
    // Public Methods
    // -------------------------------------------------------------------------
    MetadataStorage.prototype.findTransformMetadatas = function (target, propertyName, transformationType) {
        return this.findMetadatas(this._transformMetadatas, target, propertyName)
            .filter(function (metadata) {
            if (!metadata.options)
                return true;
            if (metadata.options.toClassOnly === true && metadata.options.toPlainOnly === true)
                return true;
            if (metadata.options.toClassOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_CLASS || transformationType === TransformOperationExecutor_1.TransformationType.PLAIN_TO_CLASS;
            }
            if (metadata.options.toPlainOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_PLAIN;
            }
            return true;
        });
    };
    MetadataStorage.prototype.findExcludeMetadata = function (target, propertyName) {
        return this.findMetadata(this._excludeMetadatas, target, propertyName);
    };
    MetadataStorage.prototype.findExposeMetadata = function (target, propertyName) {
        return this.findMetadata(this._exposeMetadatas, target, propertyName);
    };
    MetadataStorage.prototype.findExposeMetadataByCustomName = function (target, name) {
        return this.getExposedMetadatas(target).find(function (metadata) {
            return metadata.options && metadata.options.name === name;
        });
    };
    MetadataStorage.prototype.findTypeMetadata = function (target, propertyName) {
        return this.findMetadata(this._typeMetadatas, target, propertyName);
    };
    MetadataStorage.prototype.getStrategy = function (target) {
        var exclude = this._excludeMetadatas.find(function (metadata) { return metadata.target === target && metadata.propertyName === undefined; });
        var expose = this._exposeMetadatas.find(function (metadata) { return metadata.target === target && metadata.propertyName === undefined; });
        if ((exclude && expose) || (!exclude && !expose))
            return "none";
        return exclude ? "excludeAll" : "exposeAll";
    };
    MetadataStorage.prototype.getExposedMetadatas = function (target) {
        return this.getMetadata(this._exposeMetadatas, target);
    };
    MetadataStorage.prototype.getExcludedMetadatas = function (target) {
        return this.getMetadata(this._excludeMetadatas, target);
    };
    MetadataStorage.prototype.getExposedProperties = function (target, transformationType) {
        return this.getExposedMetadatas(target)
            .filter(function (metadata) {
            if (!metadata.options)
                return true;
            if (metadata.options.toClassOnly === true && metadata.options.toPlainOnly === true)
                return true;
            if (metadata.options.toClassOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_CLASS || transformationType === TransformOperationExecutor_1.TransformationType.PLAIN_TO_CLASS;
            }
            if (metadata.options.toPlainOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_PLAIN;
            }
            return true;
        })
            .map(function (metadata) { return metadata.propertyName; });
    };
    MetadataStorage.prototype.getExcludedProperties = function (target, transformationType) {
        return this.getExcludedMetadatas(target)
            .filter(function (metadata) {
            if (!metadata.options)
                return true;
            if (metadata.options.toClassOnly === true && metadata.options.toPlainOnly === true)
                return true;
            if (metadata.options.toClassOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_CLASS || transformationType === TransformOperationExecutor_1.TransformationType.PLAIN_TO_CLASS;
            }
            if (metadata.options.toPlainOnly === true) {
                return transformationType === TransformOperationExecutor_1.TransformationType.CLASS_TO_PLAIN;
            }
            return true;
        })
            .map(function (metadata) { return metadata.propertyName; });
    };
    MetadataStorage.prototype.clear = function () {
        this._typeMetadatas = [];
        this._exposeMetadatas = [];
        this._excludeMetadatas = [];
    };
    // -------------------------------------------------------------------------
    // Private Methods
    // -------------------------------------------------------------------------
    MetadataStorage.prototype.getMetadata = function (metadatas, target) {
        var metadataFromTarget = metadatas.filter(function (meta) { return meta.target === target && meta.propertyName !== undefined; });
        var metadataFromChildren = metadatas.filter(function (meta) { return target && target.prototype instanceof meta.target && meta.propertyName !== undefined; });
        return metadataFromChildren.concat(metadataFromTarget);
    };
    MetadataStorage.prototype.findMetadata = function (metadatas, target, propertyName) {
        var metadataFromTarget = metadatas.find(function (meta) { return meta.target === target && meta.propertyName === propertyName; });
        var metadataFromChildren = metadatas.find(function (meta) { return target && target.prototype instanceof meta.target && meta.propertyName === propertyName; });
        return metadataFromTarget || metadataFromChildren;
    };
    MetadataStorage.prototype.findMetadatas = function (metadatas, target, propertyName) {
        var metadataFromTarget = metadatas.filter(function (meta) { return meta.target === target && meta.propertyName === propertyName; });
        var metadataFromChildren = metadatas.filter(function (meta) { return target && target.prototype instanceof meta.target && meta.propertyName === propertyName; });
        return metadataFromChildren.reverse().concat(metadataFromTarget.reverse());
    };
    return MetadataStorage;
}());
exports.MetadataStorage = MetadataStorage;

//# sourceMappingURL=MetadataStorage.js.map


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var ClassTransformer_1 = __webpack_require__(7);
var storage_1 = __webpack_require__(14);
var TypeMetadata_1 = __webpack_require__(24);
var ExposeMetadata_1 = __webpack_require__(25);
var ExcludeMetadata_1 = __webpack_require__(26);
var TransformMetadata_1 = __webpack_require__(27);
/**
 * Defines a custom logic for value transformation.
 */
function Transform(transformFn, options) {
    return function (target, key) {
        var metadata = new TransformMetadata_1.TransformMetadata(target.constructor, key, transformFn, options);
        storage_1.defaultMetadataStorage.addTransformMetadata(metadata);
    };
}
exports.Transform = Transform;
/**
 * Specifies a type of the property.
 */
function Type(typeFunction) {
    return function (target, key) {
        var type = Reflect.getMetadata("design:type", target, key);
        var metadata = new TypeMetadata_1.TypeMetadata(target.constructor, key, type, typeFunction);
        storage_1.defaultMetadataStorage.addTypeMetadata(metadata);
    };
}
exports.Type = Type;
/**
 * Marks property as included in the process of transformation. By default it includes the property for both
 * constructorToPlain and plainToConstructor transformations, however you can specify on which of transformation types
 * you want to skip this property.
 */
function Expose(options) {
    return function (object, propertyName) {
        var metadata = new ExposeMetadata_1.ExposeMetadata(object instanceof Function ? object : object.constructor, propertyName, options || {});
        storage_1.defaultMetadataStorage.addExposeMetadata(metadata);
    };
}
exports.Expose = Expose;
/**
 * Marks property as excluded from the process of transformation. By default it excludes the property for both
 * constructorToPlain and plainToConstructor transformations, however you can specify on which of transformation types
 * you want to skip this property.
 */
function Exclude(options) {
    return function (object, propertyName) {
        var metadata = new ExcludeMetadata_1.ExcludeMetadata(object instanceof Function ? object : object.constructor, propertyName, options || {});
        storage_1.defaultMetadataStorage.addExcludeMetadata(metadata);
    };
}
exports.Exclude = Exclude;
/**
 * Transform the object from class to plain object and return only with the exposed properties.
 */
function TransformClassToPlain(params) {
    return function (target, propertyKey, descriptor) {
        var classTransformer = new ClassTransformer_1.ClassTransformer();
        var originalMethod = descriptor.value;
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = originalMethod.apply(this, args);
            var isPromise = !!result && (typeof result === "object" || typeof result === "function") && typeof result.then === "function";
            return isPromise ? result.then(function (data) { return classTransformer.classToPlain(data, params); }) : classTransformer.classToPlain(result, params);
        };
    };
}
exports.TransformClassToPlain = TransformClassToPlain;
/**
 * Return the class instance only with the exposed properties.
 */
function TransformClassToClass(params) {
    return function (target, propertyKey, descriptor) {
        var classTransformer = new ClassTransformer_1.ClassTransformer();
        var originalMethod = descriptor.value;
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var result = originalMethod.apply(this, args);
            var isPromise = !!result && (typeof result === "object" || typeof result === "function") && typeof result.then === "function";
            return isPromise ? result.then(function (data) { return classTransformer.classToClass(data, params); }) : classTransformer.classToClass(result, params);
        };
    };
}
exports.TransformClassToClass = TransformClassToClass;

//# sourceMappingURL=decorators.js.map


/***/ }),
/* 24 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TypeMetadata = /** @class */ (function () {
    function TypeMetadata(target, propertyName, reflectedType, typeFunction) {
        this.target = target;
        this.propertyName = propertyName;
        this.reflectedType = reflectedType;
        this.typeFunction = typeFunction;
    }
    return TypeMetadata;
}());
exports.TypeMetadata = TypeMetadata;

//# sourceMappingURL=TypeMetadata.js.map


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var ExposeMetadata = /** @class */ (function () {
    function ExposeMetadata(target, propertyName, options) {
        this.target = target;
        this.propertyName = propertyName;
        this.options = options;
    }
    return ExposeMetadata;
}());
exports.ExposeMetadata = ExposeMetadata;

//# sourceMappingURL=ExposeMetadata.js.map


/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var ExcludeMetadata = /** @class */ (function () {
    function ExcludeMetadata(target, propertyName, options) {
        this.target = target;
        this.propertyName = propertyName;
        this.options = options;
    }
    return ExcludeMetadata;
}());
exports.ExcludeMetadata = ExcludeMetadata;

//# sourceMappingURL=ExcludeMetadata.js.map


/***/ }),
/* 27 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var TransformMetadata = /** @class */ (function () {
    function TransformMetadata(target, propertyName, transformFn, options) {
        this.target = target;
        this.propertyName = propertyName;
        this.transformFn = transformFn;
        this.options = options;
    }
    return TransformMetadata;
}());
exports.TransformMetadata = TransformMetadata;

//# sourceMappingURL=TransformMetadata.js.map


/***/ }),
/* 28 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.DateUtils = void 0;
var object_utils_1 = __webpack_require__(2);
var DateUtils = /** @class */ (function () {
    function DateUtils() {
    }
    /**
     * Returns the number of milliseconds that have elapsed since 1970-01-01T00:00:00.000Z.
     * @param date
     * @example DateUtils.dateToTimestamp(null) = 0
     * @example DateUtils.dateToTimestamp(undefined) = 0
     * @example DateUtils.dateToTimestamp(new Date("Tue, 19 Jun 2018 00:00:00 GMT")) = 1529366400000
     */
    DateUtils.dateToTimestamp = function (date) {
        if (object_utils_1.ObjectUtils.isNullOrUndefined(date)) {
            return 0;
        }
        return date.getTime();
    };
    /**
     * Get date from the number of milliseconds that have elapsed since 1970-01-01T00:00:00.000Z.
     * @param timestamp
     * @example DateUtils.timestampToDate(1529366400) = new Date("Tue, 19 Jun 2018 00:00:00 GMT")
     */
    DateUtils.timestampToDate = function (timestamp) {
        return new Date(timestamp);
    };
    /**
     * Get currnet date without hours, minutes and seconds.
     */
    DateUtils.getToday = function () {
        var now = new Date();
        now.setHours(0, 0, 0, 0);
        return now;
    };
    /**
     * Converts the value of the current date to its equivalent string representation
     * using the specified format.
     * @param date
     * @param format
     * "yyyy" Year represented by four digits.
     * "yy" Year as last two digits; leading zero for years less than 10.
     * "MM" Month as digits; leading zero for single-digit months.
     * "M" Month as digits; no leading zero for single-digit months.
     * "dd" Day of the month as digits; leading zero for single-digit days.
     * "d" Day of the month as digits; no leading zero for single-digit days.
     * "HH" Hours; leading zero for single-digit hours (24-hour clock).
     * "H" Hours; no leading zero for single-digit hours (24-hour clock).
     * "mm" Minutes; leading zero for single-digit minutes.
     * "m" Minutes; no leading zero for single-digit minutes.
     * "ss" Seconds; leading zero for single-digit seconds.
     * "s" Seconds; no leading zero for single-digit seconds.
     * "SSS" Milliseconds; leading zero for single-digit seconds.
     * "S" Milliseconds; no leading zero for single-digit seconds.
     */
    DateUtils.toString = function (date, format) {
        var _this = this;
        return format.replace(this.timeFormatRegex, function (matched) {
            return _this.getTimeFormat(false, date, matched);
        });
    };
    /**
     * Converts the value of the current UTC date to its equivalent string representation
     * using the specified format.
     * @param date
     * @param format
     * "yyyy" Year represented by four digits.
     * "yy" Year as last two digits; leading zero for years less than 10.
     * "MM" Month as digits; leading zero for single-digit months.
     * "M" Month as digits; no leading zero for single-digit months.
     * "dd" Day of the month as digits; leading zero for single-digit days.
     * "d" Day of the month as digits; no leading zero for single-digit days.
     * "HH" Hours; leading zero for single-digit hours (24-hour clock).
     * "H" Hours; no leading zero for single-digit hours (24-hour clock).
     * "mm" Minutes; leading zero for single-digit minutes.
     * "m" Minutes; no leading zero for single-digit minutes.
     * "ss" Seconds; leading zero for single-digit seconds.
     * "s" Seconds; no leading zero for single-digit seconds.
     * "SSS" Milliseconds; leading zero for single-digit seconds.
     * "S" Milliseconds; no leading zero for single-digit seconds.
     */
    DateUtils.toUTCString = function (date, format) {
        var _this = this;
        return format.replace(this.timeFormatRegex, function (matched) {
            return _this.getTimeFormat(true, date, matched);
        });
    };
    /**
     *  Compares two date and returns a value indicating whether one is less than, equal to, or greater than the other.
     * @param date1
     * @param date2
     * @returns
     * - If less than 0, date1 is less than date2.
     * - If 0, date1 equals date2.
     * - If greater than 0, date1 is greater than date2.
     */
    DateUtils.compare = function (date1, date2) {
        var date1Time = date1.getTime();
        var date2Time = date2.getTime();
        if (date1Time === date2Time) {
            return 0;
        }
        else if (date1Time < date2Time) {
            return -1;
        }
        else {
            return 1;
        }
    };
    // tslint:disable-next-line: cognitive-complexity
    DateUtils.getTimeFormat = function (isUTC, date, formatKey) {
        switch (formatKey) {
            case "yyyy":
                return (isUTC ? date.getUTCFullYear() : date.getFullYear()).toString();
            case "yy":
                return (isUTC ? date.getUTCFullYear() : date.getFullYear())
                    .toString()
                    .substr(2);
            case "MM":
                var month = isUTC ? date.getUTCMonth() + 1 : date.getMonth() + 1;
                return month >= 10 ? month.toString() : "0" + month;
            case "M":
                return (isUTC
                    ? date.getUTCMonth() + 1
                    : date.getMonth() + 1).toString();
            case "dd":
                var day = isUTC ? date.getUTCDate() : date.getDate();
                return day >= 10 ? day.toString() : "0" + day;
            case "d":
                return (isUTC ? date.getUTCDate() : date.getDate()).toString();
            case "HH":
                var hour = isUTC ? date.getUTCHours() : date.getHours();
                return hour >= 10 ? hour.toString() : "0" + hour;
            case "H":
                return (isUTC ? date.getUTCHours() : date.getHours()).toString();
            case "mm":
                var min = isUTC ? date.getUTCMinutes() : date.getMinutes();
                return min >= 10 ? min.toString() : "0" + min;
            case "m":
                return (isUTC ? date.getUTCMinutes() : date.getMinutes()).toString();
            case "ss":
                var seconds = isUTC ? date.getUTCSeconds() : date.getSeconds();
                return seconds >= 10 ? seconds.toString() : "0" + seconds;
            case "s":
                return (isUTC ? date.getUTCSeconds() : date.getSeconds()).toString();
            case "SSS":
                var milliseconds = isUTC
                    ? date.getUTCMilliseconds()
                    : date.getMilliseconds();
                return milliseconds >= 100
                    ? milliseconds.toString()
                    : milliseconds >= 10
                        ? "0" + milliseconds
                        : "00" + milliseconds;
            case "S":
                return (isUTC
                    ? date.getUTCMilliseconds()
                    : date.getMilliseconds()).toString();
            default:
                return "";
        }
    };
    DateUtils.timeFormatRegex = /yyyy|yy|MM|M|dd|d|HH|H|mm|m|ss|s|SSS|S/g;
    return DateUtils;
}());
exports.DateUtils = DateUtils;
//# sourceMappingURL=date.utils.js.map

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpUtils = void 0;
var object_utils_1 = __webpack_require__(2);
var string_utils_1 = __webpack_require__(16);
var HttpUtils = /** @class */ (function () {
    function HttpUtils() {
    }
    /**
     * Get all cookie values from cookie string;
     * @param cookie
     * @example HttpUtils.getCookies(document.cookie)
     */
    HttpUtils.getCookies = function (cookie) {
        return this.getParams(cookie, "; ");
    };
    /**
     * Get all query values from url;
     * @param url
     * @example HttpUtils.getQueryParams("http://www.google.com/?search=test&id=123")
     */
    HttpUtils.getQueryParams = function (url) {
        if (!object_utils_1.ObjectUtils.isString(url)) {
            return {};
        }
        var urlItems = url.split("?");
        var queryString = urlItems.length === 1 ? urlItems[0] : urlItems[1];
        return this.getParams(queryString, "&");
    };
    HttpUtils.mergeUrl = function (url, queryParams, replaceOld) {
        var oldParams = this.getQueryParams(url);
        for (var key in queryParams) {
            if (oldParams.hasOwnProperty(key)) {
                if (replaceOld) {
                    oldParams[key] = queryParams[key];
                }
            }
            else {
                oldParams[key] = queryParams[key];
            }
        }
        var query = "";
        for (var key in oldParams) {
            var value = oldParams[key];
            if (string_utils_1.StringUtils.isBlank(query)) {
                query += key + "=" + value;
            }
            else {
                query += "&" + key + "=" + value;
            }
        }
        if (string_utils_1.StringUtils.isBlank(query)) {
            return url;
        }
        else {
            return url.split("?")[0] + "?" + query;
        }
    };
    // solve a=1[;|&]b=2[;|&]c=3
    HttpUtils.getParams = function (paramStr, splitChar) {
        var result = {};
        if (!object_utils_1.ObjectUtils.isString(paramStr) || !object_utils_1.ObjectUtils.isString(splitChar)) {
            return result;
        }
        var parts = paramStr.split(splitChar);
        for (var _i = 0, parts_1 = parts; _i < parts_1.length; _i++) {
            var part = parts_1[_i];
            var firstEqualIndex = part.indexOf("=");
            if (firstEqualIndex > 0) {
                var key = part.substring(0, firstEqualIndex);
                var value = part.substring(firstEqualIndex + 1, part.length);
                result[key] = value;
            }
            else {
                // ignore invalid key to cookie map.
            }
        }
        return result;
    };
    return HttpUtils;
}());
exports.HttpUtils = HttpUtils;
//# sourceMappingURL=http.utils.js.map

/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.RegexUtils = void 0;
var RegexUtils = /** @class */ (function () {
    function RegexUtils() {
    }
    /**
     * Escapes all reserved characters for regular expressions by preceding them with a backslash.
     * @param str target string
     * @example * => \*
     * @example ? => \?
     * @example { => \{
     * @example } => \}
     */
    RegexUtils.escapeRegExp = function (str) {
        return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
    };
    /**
     * 3 to 16 letters, numbers, underscores, or hyphens
     * @param username
     */
    RegexUtils.validateUsername = function (username) {
        var regex = /^[a-z0-9_-]{3,16}$/;
        return regex.test(username);
    };
    /**
     * Minimum eight characters, at least one letter and one number:
     * @param password
     */
    RegexUtils.validatePassword = function (password) {
        var regex = /^(?=.*[A-Za-z])(?=.*\d)[A-Za-z\d]{8,}$/;
        return regex.test(password);
    };
    /**
     * valid current input is email format.
     */
    RegexUtils.validateEmail = function (email) {
        // from: https://stackoverflow.com/questions/46155/how-to-validate-an-email-address-in-javascript
        var regex = /^(([^<>()\[\]\.,;:\s@\"]+(\.[^<>()\[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
        return regex.test(email);
    };
    return RegexUtils;
}());
exports.RegexUtils = RegexUtils;
//# sourceMappingURL=regex.utils.js.map

/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.ThreadUtils = void 0;
var ThreadUtils = /** @class */ (function () {
    function ThreadUtils() {
    }
    ThreadUtils.sleep = function (interval) {
        return new Promise(function (resolve, reject) {
            var windowHandle = setTimeout(function () {
                clearInterval(windowHandle);
                resolve();
            }, interval);
        });
    };
    return ThreadUtils;
}());
exports.ThreadUtils = ThreadUtils;
//# sourceMappingURL=thread.utils.js.map

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionUtils = void 0;
var ActionUtils = /** @class */ (function () {
    function ActionUtils() {
    }
    /**
     * if test is true, execute action
     * @param test whether is true
     * @param action action
     */
    ActionUtils.ifTrue = function (test, action) {
        if (test) {
            action();
        }
    };
    /**
     * if test is false, execute action
     * @param test whether is false
     * @param action action
     */
    ActionUtils.ifFalse = function (test, action) {
        if (!test) {
            action();
        }
    };
    return ActionUtils;
}());
exports.ActionUtils = ActionUtils;
//# sourceMappingURL=action.utils.js.map

/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.IOUtils = void 0;
var IOUtils = /** @class */ (function () {
    function IOUtils() {
    }
    /**
     * get externsion of path
     *
     * @param path url, filename or filepath
     * @returns the extension of path
     */
    IOUtils.getExtension = function (path) {
        var i = path.lastIndexOf(".");
        if (i < 0) {
            return "";
        }
        else {
            return path.substring(i);
        }
    };
    return IOUtils;
}());
exports.IOUtils = IOUtils;
//# sourceMappingURL=io.utils.js.map

/***/ })
/******/ ]);
});
//# sourceMappingURL=index.js.map